/* BEGIN: вывод медиаобъектов */
function object_new_window(width, height, id) {
	var positionLeft = (screen.availWidth  - width) / 2;
	var positionTop  = (screen.availHeight - height) / 2;
	var s = [
		'width      = '+ width,
		'height     = '+ height,
		'top        = '+ positionTop,
		'left       = '+ positionLeft,
		'location   = 0',
		'menubar    = 0',
		'status     = 0',
		'resizable  = 1'
	].join(',')
	return window.open('media-object.htm?id='+ encodeURIComponent(id), "_blank", s);
}

function object_write_to_window(element, textContent, title, options) {
	options = Object.extend({
		width: parseInt(_Xml.attr(element, 'width')),
		height: parseInt(_Xml.attr(element, 'height'))
	}, options || {});
	var alignCenter = !options.width || !options.height;
	options.width  = !options.width ? 800 : (options.width > screen.availWidth - 20 ? screen.availWidth - 20 : options.width);
	options.height = !options.height ? 600 : (options.height > screen.availHeight - 100 ? screen.availHeight - 100 : options.height);
	
	if (alignCenter) {
		textContent = '<table cellpadding="0" cellspacing="0" border="0" width="100%" height="100%"><tr><td style="text-align: center; vertical-align: middle;">'+ textContent +'</td></tr></table>';
	}

	var AC = arguments.callee;
	if (!AC.objectsHash) {
		AC.objectsHash = {};
	}
	AC.objectsHash[_Xml.id(element)] = {
		title: title,
		text: textContent
	};

	object_new_window(options.width, options.height, _Xml.id(element));
}

function object_image(element) {
	object_write_to_window(
		element,
		'<div><img src="'+ _Xml.attr(element, 'src') +'" galleryimg="no" /></div>',
		(_Xml.attr(element, 'title')||'').strip()
	);
}
function object_generate_id(element) {
	var id = _Xml.id(element) || '';
	if (id.charAt(0) == '{' && id.charAt(id.length - 1) == '}') {
		id = id.substr(1, id.length - 2);
	}
	return 'ID_' + id.replace(/-/g, '_') + '_EU';
}
function object_flash(element) {
	var id = _Xml.id(element);

	var textContent = [
		'<div id="'+ object_generate_id(element) +'"/>',
		'<img src="images/loaded.gif" onload="',
		"	embedFlashMovie('"+ id +"');",
		'" />'
	].join('\n');

	object_write_to_window(
		element,
		textContent,
		(_Xml.attr(element, 'title')||'').strip()
	);
}

function get_flash_options_for_element(element, options) {
	options = Object.extend({
		width:      (parseInt(_Xml.attr(element, 'width'))  || 800).toString(),
		height:     (parseInt(_Xml.attr(element, 'height')) || 600).toString(),
		flashvars:  {},
		params:     {},
		attributes: {},
		src:        _Xml.attr(element, 'src'),
		safeId:     object_generate_id(element),
		minVersion: '9.0.0',
		install:    'expressInstall.swf'
	}, options || {});
	
	options.flashvars = Object.extend({
	}, options.flashvars || {});

	options.params = Object.extend({
		base: _Xml.attr(element, 'base-src'),
		wmode: 'opaque',
		menu: 'false'
	}, options.params || {});

	options.attributes = Object.extend({
	}, options.attributes || {});

	return options;
}
function question_exercise_set_flash_loaded(id) {
	var AC = arguments.callee;
	if (!AC.flashes) {
		AC.flashes = [];
	}
	AC.flashes.push(id);
}
function question_exercise_get_flash_loaded(id) {
	return (question_exercise_set_flash_loaded.flashes || []).indexOf(id) != -1;
}
function embedFlashMovie(id, options) {
	var objectNode = _Xml.$(head, id);
	if (!objectNode) {
		return;
	}

	options = get_flash_options_for_element(objectNode, options);

	swfobject.embedSWF(
		options.src,
		options.safeId,
		options.width,
		options.height,
		options.minVersion,
		options.install,
		options.flashvars,
		options.params,
		options.attributes
	);

	if (!unloadFlashObjects.fl) {
		unloadFlashObjects.fl = [];
	}
	unloadFlashObjects.fl.push(options.safeId);

	return options.safeId;
}
function unloadFlashObjects() {
	question_exercise_set_flash_loaded.flashes = null;
	var AC = arguments.callee;
	if (!AC.fl) {
		AC.fl = [];
	}
	for (var i = 0, length = AC.fl.length; i < length; ++i) {
		swfobject.removeSWF(AC.fl[i]);
	}
	AC.fl = [];
}
function object_text(element) {
	_Xml.fetch(element);
	var isGlossaryItem = !!_Xml.parentOrSelf(element, 'glossary');

	var options = isGlossaryItem
		? { width: 300, height: 150 }
		: { width: 500, height: 300 };

	object_write_to_window(
		element,
		'<div style="margin: 15px;">'+ (isGlossaryItem ? '<h2 class="eAu">'+ (_Xml.attr(element, 'title')||'').strip() +'</h2>' : '') + text_transform(getNodeText(element)) +'</div>',
		_Xml.title(element),
		options
	);
}
function object_other(element) {
	var src = _Xml.attr(element, 'src');
	var id = object_generate_id(element);
	if (_Xml.attr(element, 'eAu-supported-extension') === 'false') {
		src = 'not-supported-extension.htm?'+ Object.toQueryString({
			extension: _Xml.attr(element,'eAu-filename-extension'),
			filename: src
		});
	}

	object_write_to_window(
		element,
		'<iframe frameborder="0" marginheight="0" marginwidth="0" src="'+ src +'" width="100%" height="100%" id="'+ id +'" />',
		(_Xml.attr(element, 'title')||'').strip()
	);
}

function glossary_text(id, context) {
	if (document.getElementById('eAu-glossary-item-'+id)) { return; }
	if (Object.isUndefined(getGlossary.Entries)) { return; }

	var index = getGlossary.EntriesHash[id];
	if (Object.isUndefined(getGlossary.Entries[index].text)) {
		var element = _Xml.$(head, id);
		_Xml.fetch(element);
		getGlossary.Entries[index].text = '<div class="eAu-glossary-item-fieldset-wrapper">' + text_transform(getNodeText(element)) + '</div>';
	}
	var el = document.createElement('div');
	el.className = 'eAu-glossary-item-description';
	el.id = 'eAu-glossary-item-'+id;
	$(el).html(getGlossary.Entries[index].text);
	context.parentNode.appendChild(el);
	$(context).replaceWith('<h2 class="eAu">'+ $(context).html() +'</h2>');
}
/* END: вывод медиаобъектов */
