self.QParams = document.location.search.toString().toQueryParams();
self.$window = $(window);

var use_internal_navigation_els = true;
var block_content_copy      = false;
var isELS = false;
var courseXml = 'course.xml'
try {
	nFindMetadataTries = 0;
	win = window.parent;
	while ((win.eLearning_server_metadata == null || typeof win.eLearning_server_metadata == 'undefined')
		  && (win.parent != null)
		  && (win.parent != win)) {
		nFindMetadataTries ++;
		if (nFindMetadataTries > 500) { break; }
		win = win.parent;
	}
	if (typeof win.eLearning_server_metadata != 'undefined') {
		isELS = true;
		if (!!win.eLearning_server_metadata.coursexml && win.eLearning_server_metadata.coursexml != '') {
			courseXml = win.eLearning_server_metadata.coursexml;
		}
		use_internal_navigation_els = win.eLearning_server_metadata.course_options.use_internal_navigation
		block_content_copy = win.eLearning_server_metadata.course_options.block_content_copy
	}
} catch (error) {}

var xsls = [["commonXSL", "common.xsl"], ["printXsl", "print.xsl"]];

function getSupportedExtensions() {
	var supportedExtensions = [];

	if (navigator.plugins && navigator.plugins.length > 0) {
		supportedExtensions = ['png', 'gif', 'jpg', 'jpeg', 'bmp', 'html', 'htm', 'mht', 'swf'];
		var extensionsLength = navigator.plugins.length;
		var plugs = navigator.plugins;
		for (var i = 0; i < extensionsLength; ++i) {
			var plug = plugs[i];
			for (var j = 0; j < plug.length; ++j) {
				if (!plug[j].enabledPlugin) { continue; }
				var suffixes = (plug[j].suffixes || '').split(',');
				for (var k = 0; k < suffixes.length; ++k) {
					var suffix = (suffixes[k] || '').strip();
					if (suffix && suffix != '*') {
						supportedExtensions.push(suffix.toLowerCase());
					}
				}
			}
		}
	}

	return supportedExtensions;
}

var head, courseDataLoaded = false;

function backCounter() {
	var ac = arguments.callee;
	if (Object.isUndefined(ac.documentsLeft)) {
		ac.documentsLeft = 1 + xsls.length;
	}
	if (--ac.documentsLeft == 0) {
		$window.trigger('course:data-loaded');
	}
}
// Bind events to window object
// Эти события должны быть самыми последними, т.к. 
// после их отработки выставляется флаг, что курс
// загружен и внутренний фрейм начинает выполнять код
$window
	.one('course:data-loaded', function(event) {
		courseDataLoaded = true;
	})
	.one('course:xml-loaded', backCounter)
	.bind('course:xsl-loaded', backCounter)
	.one('course:load-error', function(event) {
		$window.trigger('course:data-loaded', {error: true});
	});

eAu.preloader.add(courseXml, function(data) {
	if (!data || !data.documentElement) {
		$window.trigger('course:load-error', {file: courseXml, type: 'xml'});
		return;
	}

	head = data.documentElement;

	var Objects = _Xml.select(head, '//object[@src]');
	for (var i = 0; i < Objects.length; ++i) {
		var O = Objects[i];

		var src = O.getAttribute('src');
		O.setAttribute('xslt-src', decodeURI(src.replace(/'/g, "\\'")));

		var SplittedSrc = src.split('/');
		var filename = SplittedSrc.pop();
		O.setAttribute('base-src', decodeURI(SplittedSrc.join('/')));

		var Width = parseInt(O.getAttribute('width'), 10);
		var Height = parseInt(O.getAttribute('height'), 10);

		if (!Width || Width < 0) {
			O.setAttribute('width', '0');
		}
		if (!Height || Height < 0) {
			O.setAttribute('height', '0');
		}

		var supportedExtensions = getSupportedExtensions();
		if (supportedExtensions.length) {
			var extension = filename.split('.').pop();
			if (extension && supportedExtensions.indexOf(extension.toLowerCase()) == -1) {
				O.setAttribute('eAu-supported-extension', 'false');
				O.setAttribute('eAu-filename-extension', extension.toLowerCase());
			}
		}
		if (_Xml.parent(O, 'question-exercise')) {
			_Xml.attr(O, 'default', 'true');
			_Xml.attr(O, 'visible', 'false');
			_Xml.attr(O, 'show-in-popup', 'false');
			_Xml.attr(O, 'type', 'flash');
			var exerciseFileName = /^index.htm$/.test(filename) ? "FlashExercise.swf" : (/\.htm(l)?$/i.test(filename) ? filename.split('.')[0] + ".swf" : filename);
			_Xml.attr(O, 'src', SplittedSrc.join('/') + '/' + exerciseFileName);
			_Xml.attr(O, 'xslt-src', decodeURI(_Xml.attr(O, 'src').replace(/'/g, "\\'")));
		}
		if (_Xml.parent(O, 'references')) {
			_Xml.attr(O, 'default', 'false');
		}
	}
	//Преобразуем все имена групп в нижний регистр, что-бы уникально идентифицировать их
	var answersNodes = head.selectNodes('//question[@type = "classify"]/answers');
	for (var k = 0, length1 = answersNodes.length; k < length1; ++k) {
		var answerNodes = answersNodes[k].selectNodes('answer');
		var classes = [];
		var classesNode = head.ownerDocument.createElement('classes');
		for (var j = 0, length0 = answerNodes.length; j < length0; ++j) {
			var classGroupUC = (_Xml.attr(answerNodes[j], 'class-group') || '').strip().norm();
			var classGroup = classGroupUC.toLowerCase();
			_Xml.attr(answerNodes[j], '__eAu-class-group', classGroup);
			if (classes.indexOf(classGroup) != -1) { continue; }
			classes.push(classGroup);
			var classNode = head.ownerDocument.createElement('class');
			_Xml.attr(classNode, 'display-name', classGroupUC);
			_Xml.attr(classNode, 'name', classGroup);
			classesNode.appendChild(classNode);
		}
		answersNodes[k].parentNode.appendChild(classesNode);
	}

	document.title = _Xml.title(head);
	$window.trigger('course:xml-loaded');
}, {
	async: true,
	onError: function() {
		$window.trigger('course:load-error', {file: courseXml, type: 'xml'});
	}
});

$.each(xsls, function(i, val) {
	eAu.preloader.add("xslt/"+ val[1], function(data) {
		if (!data) {
			$window.trigger('course:load-error', {file: val[1], type: 'xsl'});
			return;
		}
		window[val[0]] = data;
		$window.trigger('course:xsl-loaded');
	}, {
		async: true,
		onError: function() {
			$window.trigger('course:load-error', {file: val[1], type: 'xsl'});
		}
	});
});

var printWindow = null;
var objectWindow = null;

var viewedItems = {};
