var DS =        eAu.DS;
var LMS =       eAu.LMS;
var Bookmarks = eAu.Bookmarks;
var Test =      eAu.Test;

var use_internal_navigation = false;

$(window).one('course:ready', function() {
	if (head) {
		window.sequencingMode = /^(linear|free)$/.test(_Xml.attr(head, 'sequencing-mode'))
			? _Xml.attr(head, 'sequencing-mode')
			: 'free';
	}

	window.use_internal_navigation = use_internal_navigation_els && !LMS.ok();
	

	$('#cont')
		.bind('mousemove', checkInnerLinks)
		.bind('keyup', checkInnerLinks);

	$('#menu-content')
		.click(function(event) {
			if (/^a$/i.test(event.target.nodeName)) {
				link_info($(event.target).attr('db-id'));
				return false;
			}
			if ($(event.target).is('.hitbox')) {
				return !toggleMenuItem($(event.target).parents('.menu-folder:first'))
			}
		})
		.bind('mousemove', checkLink)
		.bind('keyup', checkLink);

	var mode = getMode();
	var status = false;

	if (/^(main|appendix)$/.test(mode) && DS && head) {
		status = link_info(mode == 'appendix'
			? DS.get('appendix-id')
			: DS.get('id')
		);
	}
	if (!status) {
		// Либо нода не найдена, либо переход запрещён
		// Или Псевдо-модули -- поиск, глоссарий
		// Или DS отсутствует :(
		loadingProxy();
	}
});

// При загрузке цепляем необходимые события и показываем курс
$(function() {
	$('#course-title')
		.html('<span>Подождите, идёт загрузка курса</span>');
	showContentLoader();

	$(window).bind('resize', function(event, thread) {
		var AC = arguments.callee;
		var This = this;

		if (!thread) {
			if (AC.t) { clearTimeout(AC.t); }
			AC.t = setTimeout(function() {
				$(window).trigger('resize', [true]);
			}, 0);
			return;
		}
		Resizers.resize(event);
	});
	$(document).bind('mousedown', function(event) {
		var $this = $(this);
		var parent = $(event.target)
			.parents('.auto-hide')
			.filter(function(index) {
				return _Xml.attr(this, 'autohide') == "yes";
			});
		var parentButton = $(event.target).is('.button') ? $(event.target) : $(event.target).parents('.button');
		var autoHide = $('.auto-hide')
			.filter(function(index) {
				return _Xml.attr(this, 'autohide') == "yes";
			});

		var buttonToBecomeCurrent = {length: 0};

		if (parentButton.length && parentButton.attr('id')) {
			autoHide = autoHide.filter(':not(#'+ parentButton.attr('id').replace(/button-/, '') +')');
			var container = $('#'+ parentButton.attr('id').replace(/button-/, ''));
			if (container.length && container.is(':visible')) {
				buttonToBecomeCurrent = parentButton;
			}
		}

		if (parent.length) {
			autoHide = autoHide.filter(':not(#'+ parent.attr('id') +')')
			buttonToBecomeCurrent = $('#button-'+ parent.attr('id'));
		}
		var ButtonsCurrent = $('.button-current');
		if (buttonToBecomeCurrent.length) {
			ButtonsCurrent = ButtonsCurrent.filter(':not(#'+ buttonToBecomeCurrent.attr('id') +')');
			buttonToBecomeCurrent.addClass('button-current');
		}
		ButtonsCurrent.removeClass('button-current');

		$.each(autoHide, function() {
			hideElement(this);
		});
	});

	if (courseDataLoaded) {
		$(window).trigger('course:ready');
	} else {
		$(window).one('course:data-loaded', function(event) {
			$(window).trigger('course:ready');
		});
	}

	$(window).trigger('resize');
});

$(function() {
	if (hideLoader) {
		hideLoader();
	}
});

$(window).bind('load', function(event) {
	$(window).trigger('resize');
});

/* BEGIN: Content */
function showContentLoader(element) {
	element = $(element || document.getElementById('cont'));

	element
		.html('<div class="load-indicator"></div>');
}
function loadContent(element) {
	function item(node) {
		if (!node) { return ''; }

		var menu = [];

		var items = _Xml.select(node, [
			"lesson[not(@visibility = 'hidden')]",
			"unit[not(@visibility = 'hidden')]",
			"studiedproblem[not(@visibility = 'hidden')]",
			"studiedproblems[not(@visibility = 'hidden')]/studiedproblem[not(@visibility = 'hidden')]",
			"test[not(@visibility = 'hidden')]"
		].join(" | "));

		for (var i = 0; i < items.length; i++) {
			var cur = items[i];

			var link = '<a href="index.htm" target="_top" db-id="'+ _Xml.id(cur) +'" id="EU-'+_Xml.id(cur)+'" title="'+_Xml.t(cur)+'">'+_Xml.t(cur)+'</a>';

			if (/^(studiedproblem|test)$/.test(_Xml.name(cur))) {
				menu.push( '<div class="menu-item menu-'+ (_Xml.name(cur) == 'test' ? 'test' : 'leaf') +'">'+ link +'</div>' );
			} else {
				var itemContent = item(cur);
				var content = itemContent
					? '<div>'+ itemContent +'</div>'
					: '';

				link = (content == '')
					? link
					: '<span class="hitbox"></span>'+ link;
				var state = DS.has('|menu_state_'+ _Xml.id(cur))
					? DS.get('|menu_state_'+ _Xml.id(cur))
					: 'collapsed';
				menu.push( '<div ref_db_id="'+ _Xml.id(cur) +'" class="menu-item '+ (itemContent != '' ? ('menu-folder menu-folder-'+ state) : 'menu-leaf') +'">'+ link + content +'</div>' );
			}
		}
		return menu.join("");
	}

	var AC = arguments.callee;

	var studyModules = element == head
		? _Xml.child(head, 'study-modules')
		: _Xml.parentOrSelf(element, 'study-modules');

	var appendixItem = _Xml.parentOrSelf(element, 'appendix-item');

	if (!studyModules && !appendixItem) {
		studyModules = _Xml.child(
			_Xml.parentOrSelf(element, 'organization'),
			'study-modules'
		);
	}

	if (!studyModules && !appendixItem) {
		return;
	}

	var RootElement = (studyModules ? studyModules  : _Xml.child(appendixItem, 'modules'));
	var contentId =   (studyModules ? _Xml.id(head) : _Xml.id(appendixItem)) + '-content';

	if (Object.isUndefined(AC[ contentId ])) {
		var mc = document.createElement('div');
		mc.setAttribute('id', 'menu-'+ contentId);
		mc.innerHTML = item(RootElement);
		AC[ contentId ] = mc;
	}

	var menu = document.getElementById('menu-content');
	if (!menu.firstChild || menu.firstChild.id != 'menu-'+ contentId) {
		Sarissa.clearChildNodes(menu);
		menu.appendChild(AC[ contentId ]);
	}

	highlightCurrentNodePath(element);

	$('#menu-header')
		.find('h2')
		.html(studyModules ? 'Оглавление' : _Xml.title(appendixItem));
}
/* END: Content */

/* BEGIN: обработка текста */
function transformToText(element, stylesheet, options) {
	options = Object.extend({
		'parent-id': DS.get('parentId')
	}, options || {});
	return transformToTextEx(element, stylesheet, options);
}
function text_transform(text, id, title) {
	if (DS.has('search-string')) {
		var match = 0;
		var gg = new String(text);
		var ggg = text.toLowerCase();
		var pieces = [];
		var hl = DS.get('search-string').trim().toLowerCase().norm().split(' ');
		var hlnew = [];
		for (var i = 0; i < hl.length; ++i) {
			if (hl[i] && hl[i].length) { hlnew.push(hl[i]); }
		}
		hl = hlnew;
		if (hl.length && (hl.length == 1 || DS.get('search-type') == 'any')) {
			for (var i = 0; i < hl.length; ++i) {
				gg = new String(text);
				ggg = text.toLowerCase();
				pieces = [];
				do {
					var index = ggg.indexOf(hl[i]);
					if (index == -1) { break; }
					var substr0 = gg.slice(index, index + hl[i].length);
					var leftchar = gg.charAt(index-1);
					var rightchar = gg.charAt(index + hl[i].length);
					if (
						((leftchar && leftchar.match(/[\s>:\[()\\\/#*$\-=+~`«‘’‚‛“”„#*]/)) || !leftchar)
						&& ((rightchar && rightchar.match(/[\s<%\]()\\\/.:?!*#$\-=+~`,»‘’‚‛“”„…]/)) || !rightchar)
					) {
						var replacement = '<span class="eAu-search-match">'+substr0+'</span>';
						gg = gg.replace(substr0, replacement);
						pieces.push(gg.slice(0, index + replacement.length))
						gg = gg.slice(index + replacement.length);
					} else {
						pieces.push(gg.slice(0, index + hl[0].length));
						gg = gg.slice(index + hl[0].length);
					}
					ggg = gg.toLowerCase();
				} while(true);
				pieces.push(gg)
				text = pieces.join('');
			}
		} else if (hl.length) {
			do {
				var index = ggg.indexOf(hl[0]);
				if (index == -1) { break; }
				var lastIndex = ggg.indexOf(hl[hl.length - 1], index+hl[0].length);
				if (lastIndex == -1) { break; }
				var substr0 = gg.slice(index, lastIndex + hl[hl.length - 1].length);
				var substr1 = substr0.stripTags().norm().trim().toLowerCase();
				var leftchar = gg.charAt(index-1);
				var rightchar = gg.charAt(lastIndex + hl[hl.length - 1].length);
				var test = !!(
					((leftchar && leftchar.match(/[\s>:\[()\\\/#*$\-=+~`«‘’‚‛“”„#*]/)) || !leftchar)
					&& ((rightchar && rightchar.match(/[\s<%\]()\\\/.:?!*#$\-=+~`,»‘’‚‛“”„…]/)) || !rightchar)
				)
				if (substr1 == hl.join(' ') && test) {
					var replacement = '<span class="eAu-search-match eAu-search-match-'+match+'">'+substr0+'</span>';
					gg = gg.replace(substr0, replacement);
					pieces.push(gg.slice(0, index + replacement.length))
					gg = gg.slice(index + replacement.length);
					match++;
				} else {
					pieces.push(gg.slice(0, index + hl[0].length));
					gg = gg.slice(index + hl[0].length);
				}
				ggg = gg.toLowerCase();
			} while(true);
			pieces.push(gg)
			text = pieces.join('');
		}
		DS.unset('search-string');
	}

	if (!id) {
		return text;
	} else {
		try {
			$('#' + id).html(text)
		} catch (error) {}
	}
}
/* END: обработка текста */

/* BEGIN: обработка внутренних ссылок */
function processInnerLinks(link, id) {
	var element = _Xml.$(head, id);

	if (!element) { return; }

	if (!checkRights(getTargetNode(element)) || !canNavigateToNodeOnServer(element)) {
		return false;
	}

	var studiedproblem = _Xml.parent(element, 'appendix-item') ? null : _Xml.parent(element, 'studiedproblem');
	// TODO: определиться с логикой
	if ( (studiedproblem && _Xml.name(element) == 'text' && !_Xml.isGroupped(studiedproblem))
	     || !/^(text|object)$/.test(_Xml.name(element))) {
		link_info(_Xml.id(element));
	} else {
		var functionName = null;
		if (_Xml.name(element) == 'text') {
			functionName = 'text';
		} else {
			functionName = _Xml.attr(element, 'type');
		}
		if (self['object_' + functionName]) {
			self['object_' + functionName](element);
		} else {
			object_other(element);
		}
	}
	return false;
}
/* END: обработка внутренних ссылок */

function checkRights(node) {
	if (sequencingMode != 'linear' || !use_internal_navigation || !node) {
		return true;
	}

	var c = getRightsForNode(node);

	if (!c) {
		return true;
	}

	for (var i = 0, length = c.previousTestIds.length; i < length; ++i) {
		if (!Test.passed(c.previousTestIds[i])) {
			return false;
			break;
		}
	}

	return true;
}
function getRightsForNode(node) {
	var AC = arguments.callee;
	var nodeId = _Xml.id(node);
	var alowedIfWithin = ['appendixes', 'itro'];
	if (!AC.rights) {
		AC.rights = {};
	}

	if (!Object.isUndefined(AC.rights[nodeId])) {
		return AC.rights[nodeId];
	}

	// Проверяем: если нода находится внутри приложений
	// или во введении, то заносим в ХЭШ null
	// т.е. элемент всегда разрешён
	var parentNode = _Xml.parentOrSelf(node, alowedIfWithin);
	if (parentNode || !_Xml.isVisible(node, true)) {
		AC.rights[nodeId] = null;
		return AC.rights[nodeId];
	}

	// Порядок неизвестен!!!
	var previousTests = _Xml.select(node, "preceding::test");
	var previousTestIds = [];
	for (var i = 0, length = previousTests.length; i < length; ++i) {
		previousTestIds.push(previousTests[i]);
	}
	// Устанавливаем ссылку на предыдущий тест для текущего элемента
	AC.rights[nodeId] = {
		id: nodeId,
		previousTestIds: previousTestIds
	};

	return AC.rights[nodeId];
}

/* BEGIN: переход к очередному элементу */
function getTargetNode(nextNode) {
	if (!nextNode) {
		return null;
	}

	var target = _Xml.name(nextNode);
	if (target == 'studiedproblems') {
		nextNode = _Xml.child(nextNode, 'studiedproblem');
	}
	if (target == 'studiedproblem' && !_Xml.isGroupped(nextNode)) {
		nextNode = _Xml.child(nextNode, 'object text');
	} else if (/^(text|object|reference|answer|answers|question|question-exercise|modules|study-modules|intro|appendixes)$/.test(target) && !/^(studiedproblem)$/.test(_Xml.name(_Xml.parent(nextNode)))) {
		nextNode = _Xml.parent(nextNode, 'glossary references test appendix-item organization');
	}
	return nextNode;
}
function getCurrentNode() {
	return DS.has('parentId') ? _Xml.$(head, DS.get('parentId')) : !DS.get('id') ? head : _Xml.$(head, DS.get('id'));
}
// Если находимся на сервере и переходим на видимую ноду (в основном курсе)
// надо проверить, что-бы следующая нода была в пределах
// текущего рассматриваемого вопроса или теста
function canNavigateToNodeOnServer(nextNode) {
	if (!nextNode) {
		return false;
	}

	var hasHiddenParents = !!nextNode && !_Xml.isVisible(nextNode, true);
	var isAppendix = !!nextNode && !!_Xml.parentOrSelf(nextNode, 'appendixes');

	if (!use_internal_navigation && !hasHiddenParents && !isAppendix) {
		var currentNode = getCurrentNode();
		if (!currentNode) {
			return false;
		}

		var spOrTestNext = _Xml.parentOrSelf(nextNode, 'test studiedproblem subject references');
		var spOrTestCurrent = _Xml.parentOrSelf(currentNode, 'test studiedproblem subject references');

		if (!spOrTestNext || !spOrTestCurrent) {
			return false;
		}

		return _Xml.id(spOrTestNext) == _Xml.id(spOrTestCurrent);
	}
	return true;
}
function link_info(id) {
	var nextNode = !id ? head : _Xml.$(head, id);

	nextNode = getTargetNode(nextNode);
	if (!nextNode || !checkRights(nextNode) || !canNavigateToNodeOnServer(nextNode)) {
		return false;
	}

	var currentNode = getCurrentNode();
	var hasHiddenParents = !!nextNode && !_Xml.isVisible(nextNode, true);
	var isAppendix = !!nextNode && !!_Xml.parentOrSelf(nextNode, 'appendix-item');

	// В случае если DS.get('id') содержит скрытую ноду и parentId отсутсвтует, то правим DS.get('id')
	// Это, наверное бывает если в index.htm был передан id скрытой ноды. В таком случае
	// prentId не установлен
	if (!DS.has('parentId') && !_Xml.isVisible(currentNode, true)) {
		DS.set('id', _Xml.id(head));
	}

	var target = _Xml.name(nextNode);

	if (hasHiddenParents && !DS.has('parentId')) {
		DS.set('parentId', DS.get('id'));
	}
	if (!hasHiddenParents && !isAppendix && target != 'glossary') {
		DS.unset('parentId');
	}

	id = _Xml.id(nextNode);

	if (['organization', 'unit', 'lesson', 'glossary', 'studiedproblem', 'test', 'object', 'subject', 'references', 'text', 'appendix-item'].indexOf(target) == -1) {
		alert('Невозможно произвести просмотр, выберите другой элемент');
		return false;
	}

	if (isAppendix) {
		DS.set('appendix-id', id);
	} else {
		DS.unset('appendix-id');
		currentNode = getTargetNode(_Xml.$(head, DS.get('id')));
		if (currentNode && _Xml.name(currentNode) == 'glossary') {
			id = _Xml.id(head);
		} else if (target == 'glossary') {
			id = _Xml.id(currentNode);
		}
		DS.set('id', id);
	}

	DS.unset('search');
	if (target == 'glossary') {
		DS.set('glossary', '');
	} else {
		DS.unset('glossary');
	}
	loadingProxy();
	return true;
}
/* END: переход к очередному элементу */

/* BEGIN: Переключение режимов */
function switchMode(mode) {
	var oldMode = window.currentMode;
	window.currentMode = mode;

	var classes2add = [];
	var classes2remove = [];

	var isAppendix = $(document.body).is('.appendix-mode');
	var isGlossary = $(document.body).is('.glossary-mode');
	var isSearch = $(document.body).is('.search-mode');

	if ( (mode == 'glossary' || mode == 'search' || mode == 'appendix')) {
		if (!isAppendix)
			classes2add.push('appendix-mode');
	} else {
		classes2remove.push('appendix-mode');
	}

	if (mode == 'glossary' && !isGlossary) {
		classes2add.push('glossary-mode');
		$('#print-button').hide();
	} else if (isGlossary) {
		classes2remove.push('glossary-mode');
	}

	if (mode == 'search' && !isSearch) {
		classes2add.push('search-mode');
		$('#print-button').hide();
	} else if (isSearch) {
		classes2remove.push('search-mode');
	}

	if (classes2remove.length) {
		$(document.body)
			.removeClass(classes2remove.join(' '));
	}
	if (classes2add.length) {
		$(document.body)
			.addClass(classes2add.join(' '));
	}

	if (oldMode != mode) {
		$(document).trigger('mode:changed');
	}
}
/* END: Переключение режимов */

/* BEGIN: Загрузка и управление переключалкой режимов */
function generateBookmarksList() {
	if (!Bookmarks.count()) {
		$('#bookmarks-content-bookmarks-list').html('');
		$(window).trigger('resize', [true]);
		return;
	}

	var BookmarksCont = [];
	var list = Bookmarks.list();

	var id = DS.has('appendix-id') ? DS.get('appendix-id') : DS.get('id');

	BookmarksCont.push('<div class="bookmarks-content-appendixes">');
	for (var i = 0, length = list.length; i < length; ++i) {
		BookmarksCont.push('<div class="line"><img src="images/delete-bookmark.gif" title="Удалить закладку" class="delete-bookmark" db_id="' + list[i].id + '" /><a href="index.htm" onclick="link_info(\''+ list[i].id +'\'); return false;" target="_top" id="EU-BOOKMARK-'+ list[i].id +'" class="'+ (id == list[i].id ? 'current' : '') +'">'+ list[i].title +'</a></div>');
	}
	BookmarksCont.push('</div>');

	$('#bookmarks-content-bookmarks-list').html(
		text_transform(BookmarksCont.join('\n'))
	);

	$(window).trigger('resize', [true]);
}

function loadModeSwitcher(node) {
	var appendixes = head.selectNodes("//appendix-item");
	var glossary = head.selectNodes("//glossary");
	
	var currentMode = window.currentMode;
	var cont = [];

	$('#buton-mode-appendix')
		.unbind('click')
		.click(function(event) {
			modeSwitcherContentShow('app', this);
		});

	$('#buton-mode-study')
		.unbind('click')
		.click(function(event) {
			modeSwitcherContentShow(null, this);
		});

	if (glossary.length == 1) {
		cont.push('<div class="line glossary-line '+(currentMode == 'glossary' ? 'current' : '')+'"><a href="index.htm" target="_top" id="button-link-mode-glossary" mode="glossary">Глоссарий</a></div>');
	}
	cont.push('<div class="line search-line '+(currentMode == 'search' ? 'current' : '')+'"><a href="index.htm" target="_top" id="button-link-mode-search" mode="search">Расширенный поиск</a></div>');
	if (appendixes.length > 0) {
		cont.push('<div class="dotted-line"></div>');
		var currentAppendix = _Xml.parentOrSelf(node, 'appendix-item');
		for (var i = 0; i < appendixes.length; i++) {
			cont.push('<div class="line appendix-line '+ (currentMode == 'appendix' && currentAppendix == appendixes.item(i) ? 'current' : '') +'"><a href="index.htm" target="_top" db-id="'+ _Xml.id(appendixes.item(i)) +'" id="button-link-mode-appendix-'+ _Xml.id(appendixes.item(i)) +'" mode="appendix">'+ _Xml.title(appendixes.item(i)) +'</a></div>');
		}
	}

	$('#mode-content-appendixes')
		.unbind('click')
		.click(function(event) {
			var $target = $(event.target);
			if (!$target.is('a')) { return; }
			var href = $target.attr('mode');

			if (/^(glossary|search|appendix)$/.test( href )) {
				$('#mode-current').html('Дополнительные возможности');
				$(this).find('.current').removeClass('current');
				$target.addClass('current');
			}

			if (/^glossary$/.test( href )) {
				loadGlossaryPageEx();
			} else if (/^search$/.test( href )) {
				loadSearchPageEx();
			} else if (/^appendix$/.test( href )) {
				link_info($target.attr('db-id'));
			}
			return false;
		})
		.html(cont.join(''));

	arguments.callee.loaded = true;
}
function switchToMainMode() {
	if (window.currentMode == 'main') { return; }
	var node = DS.has('id')
		? _Xml.$(head, DS.get('id'))
		: head;

	$('#mode-current').html('Обучение');
	link_info(_Xml.id(node));
	return true;
}
function modeSwitcherContentShow(what, context) {
	context = $(context);
	$(context).parent().find('a').removeClass('button-mode-current').end().end().addClass('button-mode-current');

	$('#mode .mode-content')
		.hide();

	if (what == 'app') {
		$('#mode-content-appendix').show()
	} else {
		$('#mode-content-main').show();
		switchToMainMode();
	}

	$(window).trigger('resize', [true]);
}
function loadBookmarks() {
	generateBookmarksList();

	$('#add-bookmark')
		.unbind('click')
		.click(function(event) {
			if (/^(glossary|search)$/.test(window.currentMode.toLowerCase())) {
				return;
			}

			var id = DS.has('appendix-id') ? DS.get('appendix-id') : DS.get('id');
			Bookmarks.add(id);
			
			if (Bookmarks.count() >= 10) {
				$('#add-bookmark')
					.hide();
			}

			generateBookmarksList();
		});

	arguments.callee.loaded = true;
}
function showBookmarks() {
	if (!loadBookmarks.loaded) {
		loadBookmarks();
		$(document).bind('node:changed', function() {
			setTimeout(function() {
				$('#add-bookmark')
					.hide();

				$('#bookmarks-content-bookmarks-list .current')
					.removeClass('current');

				if (/^(glossary|search)$/.test(window.currentMode.toLowerCase())) {
					return;
				}

				var id = DS.has('appendix-id') ? DS.get('appendix-id') : DS.get('id');

				if (_Xml.$(head, id)) {
					$(document.getElementById('EU-BOOKMARK-' + id))
						.addClass('current');

					if (Bookmarks.count() < 10) {
						$('#add-bookmark')
							.css('display', 'block');
					}
				}
			}, 0);
		});
		
		$(document).bind('test:passed', function() {
			setTimeout(function() {
				generateBookmarksList();
			}, 0);
		});

		$('#bookmarks-content-bookmarks-list')
			.click(function(event) {
				if (!event.target || !/^img$/.test(_Xml.name(event.target)) || !$(event.target).is('.delete-bookmark')) {
					return false;
				}

				var id = $(event.target)
					.attr('db_id');

				Bookmarks.del(id);

				if (Bookmarks.count() < 10) {
					$('#add-bookmark')
						.css('display', 'block');
				}

				generateBookmarksList();
				return false;
			});

		$(document).trigger('node:changed');
	}

	if (toggleElementVisibility($('#bookmarks'))) {
		$(window).trigger('resize');
	}
}
function showModeSwitcher(node) {
	if ($(document.body).hasClass('search-only')) {
		if (window.currentMode == 'main') {
			loadSearchPageEx();
		} else {
			switchToMainMode();
		}
		return;
	}
	if (!loadModeSwitcher.loaded) {
		loadModeSwitcher(node);
		$(document).bind('mode:changed', function(event) {
			setTimeout(function() {
				var currentMode = window.currentMode;

				$('#mode .button')
					.removeClass('button-mode-current');

				$('#mode-content-appendixes')
					.find('.current')
					.removeClass('current');

				$('#mode .mode-content')
					.hide();

				if (currentMode != 'main') {
					$('#mode-current').html('Дополнительные возможности');
					$('#buton-mode-appendix').addClass('button-mode-current');
					$('#mode-content-appendix').show();

					var target;
					if (/^(search|glossary)$/.test(currentMode)) {
						target = $('#button-link-mode-'+currentMode);
					} else {
						var node = _Xml.$(head, DS.get('appendix-id'));
						node = _Xml.parentOrSelf(node, 'appendix-item');
						target = $(document.getElementById('button-link-mode-appendix-'+_Xml.id(node)));
					}
					target
						.addClass('current');
				} else {
					$('#mode-current').html('Обучение');
					$('#buton-mode-study').addClass('button-mode-current');
					$('#mode-content-main').show();
				}
			}, 0);
		});

		$(document).trigger('mode:changed');
	}

	if (toggleElementVisibility($('#mode'))) {
		$(window).trigger('resize');
	}
}
/* END: Загрузка и управление переключалкой режимов */
function scrollMenuIntoView(element) {
	if (!highlightCurrentNodePath.FirstHtmlElement) { return; }
	var FirstHtmlElement = $(highlightCurrentNodePath.FirstHtmlElement);

	var menuOverflow       = $('#menu-overflow');
	var menuContentWrapper = $('#menu-content').parent();
	if (!menuOverflow.length || !menuContentWrapper.length) { return; }

	arguments.callee.scrolled = true;

	var PrePadding = 14;
	var menuOverflowScrollTop = menuOverflow.scrollTop();
	var menuOverflowHeight = menuOverflow.height();
	var menuContentHeight = menuContentWrapper.height()
		+ parseInt(menuContentWrapper.css('padding-top'), 10)
		+ parseInt(menuContentWrapper.css('padding-bottom'), 10);
	
	var ScrollAmount = FirstHtmlElement.position().top - menuOverflow.position().top - PrePadding;

	if (ScrollAmount + menuOverflowScrollTop + menuOverflowHeight > menuContentHeight) {
		ScrollAmount = menuContentHeight - menuOverflowHeight - menuOverflowScrollTop + PrePadding;
	}

	if (ScrollAmount == 0) { return; }
	if (Math.abs(ScrollAmount) < 5) {
		menuOverflow.scrollTop(menuOverflowScrollTop + ScrollAmount);
	} else {
		menuOverflow.animate({
			scrollTop: '+=' + ScrollAmount + 'px'
		}, 1000, ScrollAmount > 0 ? 'easeOutBounce' : 'easeInOutBounce');
	}
}
function highlightCurrentNodePath(element) {
	if (DS.has('parentId')) {
		element = _Xml.$(head, DS.get('parentId'));
	}
	if (!element) { return; }
	var id,
	    cur = element,
	    CurHtmlElement;

	var currentHighlightedElements = $('#menu-content')
		.find('.current')
		.removeClass('current');

	do {
		id = _Xml.id(cur);
		var old = cur;
		cur = _Xml.parent(cur);

		if (!checkRights(old) || !canNavigateToNodeOnServer(old)) { continue; }

		CurHtmlElement = document.getElementById('EU-' + id);
		if (!CurHtmlElement) { continue; }
		if (!arguments.callee.FirstHtmlElement) {
			arguments.callee.FirstHtmlElement = CurHtmlElement;
			$(CurHtmlElement).addClass('current-first');
		}
		$(CurHtmlElement).addClass('current');
		expandMenuItem($(CurHtmlElement).parents('.menu-folder:first'));
	} while (cur);
}
function toggleMenuItem($node) {
	if (!$node.length) {
		return false;
	}

	var node = $node.get(0);
	
	var dbId = _Xml.attr(node, 'ref_db_id');
	if (/collapsed/.test(node.className || '')) {
		$node
			.removeClass('menu-folder-collapsed')
			.addClass('menu-folder-expanded');
		DS.set('|menu_state_' + dbId, 'expanded');
	} else {
		$node
			.removeClass('menu-folder-expanded')
			.addClass('menu-folder-collapsed');
		DS.unset('|menu_state_' + dbId);
	}
	$(window).trigger('resize', [true]);
}
function expandMenuItem($node) {
	if (!$node.length) {
		return false;
	}

	if (/collapsed/.test($node.get(0).className)) {
		$node
			.removeClass('menu-folder-collapsed')
			.addClass('menu-folder-expanded');
	}
}

function clearSlider() {
	$('#slider')
		.unbind('click')
		.css('display', 'none')
		.html('');

	$('#slider-td')
		.css('width', '0px');
}

function loadBreadedCrumbs(node) {
	if (!node) {
		$('#breaded-crumbs').hide();
		return;
	}

	var isNonInteractiveNode = /^(question|question-exercise)$/.test(_Xml.name(node));
	var nodesPath = [];
	var Parent = node;
	var hasInvisibleNode = false;
	while (Parent && _Xml.name(Parent) != 'study-modules' && _Xml.name(Parent) != 'appendixes') {
		if (/^(modules|studiedproblems|question-group|intro|subject|references)$/.test(_Xml.name(Parent)) ) {
			Parent = _Xml.parent(Parent);
			continue;
		}
		nodesPath.push(Parent);
		if (!_Xml.isVisible(Parent)) {
			hasInvisibleNode = true;
			break;
		}
		Parent = _Xml.parent(Parent);
	}
	var nodesPathStr = [];
	nodesPath = nodesPath.reverse();
	var li;
	for (var i = 0; i < nodesPath.length; ++i) {
		function gTitle(node) {
			if (/^(studiedproblem|question|question-exercise)$/.test(_Xml.name(node))) {
				return (_Xml.attr(node, 'title') || '').strip();
			} else {
				return _Xml.title(node);
			}
		}
		if (_Xml.name(nodesPath[i]) == 'studiedproblem' && _Xml.attr(nodesPath[i], 'group-text-nodes') == 'false') {
			continue;
		}
		if (nodesPath.length == i+1 && !/^(glossary|search)$/.test(getMode())) {
			nodesPathStr.push(gTitle(nodesPath[i]));
		} else {
			if (isNonInteractiveNode || !canNavigateToNodeOnServer(nodesPath[i]) || !checkRights(nodesPath[i])) {
				nodesPathStr.push(gTitle(nodesPath[i]));
			} else {
				li = 'link_info(\''+_Xml.id(nodesPath[i])+'\'); return false;';
				nodesPathStr.push('<a href="index.htm" onclick="' + li + '" target="_top">' + gTitle(nodesPath[i]) + '</a>');
			}
		}
	}
	if (nodesPathStr.length) {
		$('#breaded-crumbs-content').html(nodesPathStr.join(' <span>→</span> '));
		$('#breaded-crumbs').show();
	} else {
		$('#breaded-crumbs').hide();
	}
}

function loadSlider(node) {
	clearSlider();
	if (['text', 'studiedproblem', 'object', 'test'].indexOf(_Xml.name(node)) == -1) {
		return;
	}

	var root = node;
	while (root && _Xml.name(root) != 'lesson' && _Xml.isVisible(root)) {
		root = _Xml.parent(root);
	}
	if (!root) { return; }
	var XPath = [
		'studiedproblem[not(@group-text-nodes = "false") and not(@visibility = "hidden")]',
		'studiedproblem[@group-text-nodes = "false" and not(@visibility = "hidden")]/text[not(@visibility = "hidden")]',
		'studiedproblem[@group-text-nodes = "false" and not(@visibility = "hidden")]/object[not(@visibility = "hidden")]',
		'studiedproblems[not(@visibility = "hidden")]/studiedproblem[not(@group-text-nodes = "false") and not(@visibility = "hidden")]',
		'studiedproblems[not(@visibility = "hidden")]/studiedproblem[@group-text-nodes = "false" and not(@visibility = "hidden")]/text[not(@visibility = "hidden")]',
		'studiedproblems[not(@visibility = "hidden")]/studiedproblem[@group-text-nodes = "false" and not(@visibility = "hidden")]/object[not(@visibility = "hidden")]',
		'test[not(@visibility = "hidden")]',
		'text[not(@visibility = "hidden")]'
	];
	var unFilteredNodes = root.selectNodes(XPath.join('|'));
	var nodes = [];
	for (var i = 0; i < unFilteredNodes.length; ++i) {
		if (!canNavigateToNodeOnServer(unFilteredNodes[i])) {
			continue;
		}
		nodes.push(unFilteredNodes[i]);
	}
	if (!nodes.length || nodes.length == 1) { return; }

	var ac = arguments.callee;
	if (!ac.sliderItem) {
		var sliderClone = $($('#slider').get(0).cloneNode(false));
		sliderClone
			.css('position', 'absolute')
			.attr('id', '');
		hideElement(sliderClone);
		sliderClone
			.show()
			.html('<a id="eAu-slider-item-size-stub" class="slider-item" href="index.htm"><span></span></a>');

		$('#slider').after(sliderClone);

		ac.sliderItem = {
			width: $('#eAu-slider-item-size-stub').outerWidth(true),
			spacing: 0
		}
		sliderClone.remove();
	}

	var slider = [];
	for (var i = 0; i < nodes.length; ++i) {
		var clasS = (_Xml.id(nodes[i]) == _Xml.id(node))
			? 'current'
			: isItemViewed(nodes[i])
				? 'passed'
				: '';
		var str = checkRights(nodes[i]) && canNavigateToNodeOnServer(nodes[i])
			? '<a title="'+ _Xml.title(nodes[i]) +'" class="'+ clasS +' slider-item" href="index.htm" target="_top" db-id="'+ _Xml.id(nodes[i]) +'" node-name="'+ _Xml.name(nodes[i]) +'"><span></span></a>'
			: '<div title="'+ _Xml.title(nodes[i]) +'" class="'+ clasS +' slider-item"><span></span></div>'
		slider.push(str);
	}

	var sliderWidth = nodes.length * ac.sliderItem.width + (nodes.length - 1) * ac.sliderItem.spacing + 2 * ac.sliderItem.spacing;
	$('#slider-td')
		.css('width', sliderWidth > 340 ? 340 : sliderWidth);
	$('#slider')
		.unbind('click')
		.click(function(event) {
			var a = _Xml.parentOrSelf(event.target, 'a');
			if (!a) { return; }
			if (!$(a).hasClass('slider-item') || $(a).attr('node-name') == 'question' || $(a).attr('node-name') == 'question-exercise') { return false; }
			link_info($(a).attr('db-id'));
			return false;
		})
		.css('display', 'block')
		.html(slider.join(''));
}
function toggleDescription(what, context) {
	var node = document.getElementById(what);
	if (!node) { return; }
	var isVisible = $(node)
		.toggle()
		.is(':visible');

	if (isVisible) {
		var element = _Xml.$(head, what.substr(15));
		var h2 = _Xml.parent(context, 'h2');
		if (h2 && !checkRights(element)) {
			$(_Xml.parent(h2))
				.addClass('eAu-access-forbidden-links')
		}
		$(context)
			.removeClass('button-expand')
			.addClass('button-collapse')
			.attr('title', 'Свернуть описание');
	} else {
		$(context)
			.removeClass('button-collapse')
			.addClass('button-expand')
			.attr('title', 'Развернуть описание');
	}
}
function setButton(buttonType, handler, title) {
	var supported = ['next', 'previous', 'next-question', 'previous-question', 'answer-question'];

	if (!buttonType) {
		for (var i = 0, length = supported.length; i < length; ++i) {
			setButton(supported[i]);
		}
	}

	if (supported.indexOf(buttonType) == -1) { return; }

	// Хак :)
	var newButtonType = buttonType.replace('-question', '');
	var button = $('#button-'+ newButtonType);

	if (!handler) {
		button
			.unbind('click')
			.attr('title', '')
			.addClass('button-hidden');
		return;
	}

	var prefix = buttonType == 'next' ? 'Далее: ' : buttonType == 'previous' ? 'Назад: ' : '';

	button
		.unbind('click')
		.click(function(event){
			handler(event);
			return false;
		})
		.attr('title', prefix + title)
		.removeClass('button-hidden');
}

$window.one('course:ready', function(event) {
	var headerIsVisible = !((window.isELS || !use_internal_navigation) && head && _Xml.attr(head, 'els-hide-header') == 'true');
	if (!headerIsVisible) {
		return;
	}
	if (DS.get('|header_state') == 'collapsed') {
		$('#layout-header')
			.hide();
		$('#header-collapser')
			.attr('title', 'Показать заголовок')
			.addClass('collapsed');

		$window.trigger('resize');
	} else {
		$('#header-collapser')
			.attr('title', 'Скрыть заголовок');
	}

	$('#header-collapser')
		.click(function() {
			var shouldIResizeImmediatly = !$('#layout-header').is(':visible');

			$('#layout-header')
				.toggle('drop', {
					direction: 'right',
					distance: $window.width() * 4.0 / 5.0
				}, 400, function() {
					this.style.opacity = '';
					this.style.filter = '';

					if (!$(this).is(':visible')) {
						DS.set('|header_state', 'collapsed');
						$window.trigger('resize', [true]);

						$('#header-collapser')
							.addClass('collapsed')
							.attr('title', 'Показать заголовок');
					} else {
						DS.unset('|header_state');

						$('#header-collapser')
							.removeClass('collapsed')
							.attr('title', 'Скрыть заголовок');
					}
				});

				shouldIResizeImmediatly && $window.trigger('resize', [true]);
		})
		.show();
});

function loadNavInfo(node) {
	var currentMode = window.currentMode;
	var isServerMode = !use_internal_navigation;

	// Если курс запущен в eLS, то предупредим его
	if (isServerMode && !$(document.body).is('.server-mode')) {
		$(document.body).addClass('server-mode');
	}
	if (document.location.protocol.indexOf('http') == 0 && !$(document.body).is('.http-mode')) {
		$(document.body).addClass('http-mode');
	}

	var isMenuLayoutStatic = (use_internal_navigation || currentMode != 'main') && (/^(unit|lesson)$/.test(_Xml.name(node)) || _Xml.parentOrSelf(node, 'appendix-item'));

	$(document).trigger('node:changed');

	var headerIsVisible = !((window.isELS || !use_internal_navigation) && _Xml.attr(head, 'els-hide-header') == 'true');
	if (!headerIsVisible) {
		$('#layout-header').hide();
	}

	var isNonInteractiveNode = /^(question|question-exercise)$/.test(_Xml.name(node));

	// Установка заголовка курса
	if (headerIsVisible) {
		$('#course-title')
			.html('<span>'+_Xml.title(head)+'</span>');
		$('#course-logo, #course-title')
				.unbind('click')
				.attr('title', '')
				.css('cursor', 'default');

		var LogoUrl = _Xml.attr(head, 'src');
		if (LogoUrl && !arguments.callee.logoLoaded && $('#course-logo').length == 1) {
			var image = new Image();
			image.onload = function() {
				if (image.height > 128) {
					var d = image.height / 128;
					$('#course-logo').attr('height', 128);
					$('#course-logo').attr('width', parseInt(image.width / d));
				}
				$(window).trigger('resize');
				image.onload = null;
				image = null;
				$('#course-logo').attr('src', LogoUrl);
				loadNavInfo.logoLoaded = true;
			}
			image.src = LogoUrl;
		}

		if (use_internal_navigation && !isNonInteractiveNode) {
			$('#course-title, #course-logo')
				.click(function() {
					link_info(_Xml.id(head));
					return false;
				})
				.attr('title', 'К описанию курса')
				.css('cursor', 'pointer');
		}
	}

	// Управление кнопками
	if (typeof arguments.callee.Handlers != "object") {
		arguments.callee.Handlers = {
			menu: function(event) {
				if (toggleElementVisibility($('#menu'))) {
					$(window).trigger('resize');
				}
			},
			print: function(event) {
				PrintNode(node);
			},
			bookmarks: function(event) {
				showBookmarks();
			},
			mode: function(event) {
				showModeSwitcher(node);
			},
			help: function(event) {
				if (toggleElementVisibility($('#help'))) {
					$(window).trigger('resize');
				}
			}
		};
	}
	var Handlers = arguments.callee.Handlers;
	var Button = {
		menu: {
			isVisible: !(isServerMode || isNonInteractiveNode || isMenuLayoutStatic),
			event: 'click'
		},
		print: {
			isVisible: (currentMode == 'appendix'),
			event: 'click'
		},
		bookmarks: {
			isVisible: !(isServerMode || isNonInteractiveNode),
			event: 'click'
		},
		mode: {
			isVisible: !isNonInteractiveNode,
			event: 'click'
		},
		help: {
			isVisible: true,
			event: 'click'
		}
	};

	for (var item in Button) {
		var it = Button[item];
		it.event = it.event || 'click';
		var handler = Object.isFunction(Handlers[item])
			? Handlers[item]
			: null;
		if (handler) {
			$('#button-'+ item).unbind(it.event, it.handler);
		}
		if (it.isVisible) {
			$('#button-'+ item).removeClass('button-hidden');
			if (handler) {
				$('#button-'+ item).bind(it.event, handler)
			}
		} else {
			$('#button-'+ item).addClass('button-hidden');
		}
	}

	if ((currentMode == 'main' || currentMode == 'appendix') && isMenuLayoutStatic) {
		showElement($('#menu'));
	}

	// Загружаем строку быстрой навигации
	if (currentMode == 'main') {
		loadSlider(node);
	} else {
		clearSlider();
	}

	// Загружаем хлебные крошки
	loadBreadedCrumbs(node);

	// Если в курсе нет ни одного приложения, то заменим
	// кнопку переключения режимов на кнопку поиска
	var hasModes = true;
	var appendixes = head.selectNodes("//appendix-item");
	var glossary = head.selectNodes("//glossary");
	if (appendixes.length + glossary.length != 0) {
		$('#button-mode')
			.attr('title', 'Режимы');
	} else {
		$(document.body)
			.addClass('search-only');
		if (currentMode == 'main') {
			$('#button-mode').attr('title', 'Поиск');
		} else {
			$('#button-mode').attr('title', 'Вернуться к режиму обучения');
		}
	}

	if (isNonInteractiveNode) {
		$(document).trigger('mousedown');
	}

	// Кнопки навигации по курсу
	var siblings = eU.navigation.findSiblings(node);

	setButton();

	if (currentMode == 'main') {
		if (siblings.next && checkRights(siblings.next) && canNavigateToNodeOnServer(siblings.next)) {
			setButton('next', function() { link_info(_Xml.id(siblings.next)); }, _Xml.title(siblings.next));
		}
		if (siblings.prev && checkRights(siblings.prev) && canNavigateToNodeOnServer(siblings.prev)) {
			setButton('previous', function() { link_info(_Xml.id(siblings.prev)); }, _Xml.title(siblings.prev));
		}
	}

	window.currentNode = node; // для печати

	if (/main|appendix/.test(currentMode) && isMenuLayoutStatic) {
		if (!$(document.body).is('.menu-layout-static')) {
			$(document.body)
				.addClass('menu-layout-static');
		}
		$('#menu')
			.attr('autohide', 'no');
	} else {
		if ($(document.body).is('.menu-layout-static')) {
			$(document.body)
				.removeClass('menu-layout-static');
		}
		$('#menu')
			.attr('autohide', 'yes');
	}
	$(document).trigger('mousedown');

	// Если мы находимся в основном режиме обучения
	// разрешена внутренняя навигация курса, то
	// загружаем оглавление
	if (currentMode == 'main' && use_internal_navigation) {
		loadContent(node);
	}
	// Если-же режим обучения - приложения, то загружаем оглавление приложения
	if (currentMode == 'appendix') {
		loadContent(node);
	}

	$(window).trigger('resize', [true]);
	return siblings;
}

function PrintNode(node) {
	var l = parseInt( (1/3*screen.availWidth)/2, 10);
	var t = parseInt( (1/3*screen.availHeight)/2, 10);
	var s = "width="+parseInt(2/3*screen.availWidth, 10)+", height="+parseInt(2/3*screen.availHeight)+", top="+t+", left="+l+",location=0, menubar=0, status=0, resizable=1, scrollbars=1";
	window.curNode = node;

	if (node && node.nodeType == 1) {
		_Xml.fetch(node, true);
	} else {
		_Xml.fetch(head, true);
	}
	try {
		window.printWindow.location.reload();
	} catch (error) {
		window.printWindow = window.open("print.htm", "_blank", s);
	}
}

if (block_content_copy) {
	eAu.contentBlocker.enable();
}

function getMode() {
	if (!DS) { return; }
	return DS.has('search')
		? 'search'
		: DS.has('glossary')
			? 'glossary'
			: DS.has('appendix-id')
				? 'appendix'
				: 'main';
}

function showError(title, text, level) {
	$('#cont')
		.html('<div class="eU-error"><h2 class="eU-error-title">'+ title +'</h2><div class="eU-error-text">'+ text +'</div></div>');
	if (level == 'crytical') {
		$('#course-title')
			.html('<span><i>Ошибка при загрузке курса</i></span>')
		$('#layout-bottom')
			.hide();
		$(window).trigger('resize');
	}
}

function markItemAsViewed(node) {
	if (Object.isString(node))
		node = _Xml.$(head, node);
	if (!node)
		return;

	DS.set('|node_viewed_'+ _Xml.id(node), 'yes');
}
function isItemViewed(node) {
	if (Object.isString(node))
		node = _Xml.$(head, node);
	if (!node)
		return false;

	return DS.get('|node_viewed_'+ _Xml.id(node)) == 'yes';
}

// Загрузка элементов
function loadingProxy() {
	if (arguments.callee.t) {
		clearTimeout(arguments.callee.t);
	}
	destroySortables();
	unloadFlashObjects();

	$('#content')
		.scrollTop(0)
		.find('#cont');

	showContentLoader();

	if (!DS) {
		showError('Этот файл не может быть открыт напрямую', 'Что-бы приступить к изучению курса вы должны открыть файл «<code>index.htm</code>» в любом, установленном у вас браузере.', 'crytical');
		return;
	} else if (!head) {
		showError('Содержимое курса не найдено или повреждено', 'Неудалось загрузить файл «<code>'+ courseXml +'</code>».<br />'
		+ (Prototype.Browser.IE ? 'Возможные причины: <ul><li>вы запретили создание ActiveX объектов в настройках браузера</li><li>файл отсутсвует или повреждён</li></ul>' : '')
		+ 'Обратитесь в службу тех. поддержки для устранения неисправностей.', 'crytical');
		return;
	} else if (!window.commonXSL || !window.printXsl) {
		showError('Файлы курса не найдены или повреждены', 'Неудалось загрузить один или несколько файлов курса, необходимых для его корректной работы. Обратитесь в службу тех. поддержки для устранения неисправностей.', 'crytical');
		return;
	}

	var mode = getMode();

	var id = DS.has('appendix-id')
		? DS.get('appendix-id')
		: DS.get('id');

	var node = id ? _Xml.$(head, id) : null;

	switchMode(mode);

	var neighbours = loadNavInfo(node ? getTargetNode(node) : head);

	if (!node && id) {
		// TODO: проверить строки
		showError('Невозможно найти элемент', 'Неудалось найти указанный элемент в структуре курса «<code>'+ id +'</code>». Обратитесь к разработчикам курса или в службу тех. поддержки для устранения неисправностей.');
		return;
	}

	if (!checkRights(node)) {
		showError('Вы ещё не прошли все необходимые тесты', 'Вам необходимо пройти все тесты, предшествующие данному разделу.');
		return;
	} else if (!canNavigateToNodeOnServer(node)) {
		showError('Вы не можете просмотреть раздел', 'Воспользуйтесь оглавлением серевера.');
		return;
	}

	var functionName = 'load' + (mode == 'main' ? '' : '_' + mode) + (/^(appendix|main)$/.test(mode) ? '_' + _Xml.name(node) : '');

	if (window[functionName]) {
		markItemAsViewed(node);
		arguments.callee.t = setTimeout(function() {
			window[functionName](node, neighbours);
		}, 0);
	} else {
		// TODO: проверить строки
		showError('Невозможно отобразить содержимое раздела', 'Неудалось загрузить содержимое раздела. Отсутствует функция обработки данного типа модулей «<code>'+ _Xml.name(node) +'</code>». Обратитесь к разработчикам курса или в службу тех. поддержки для устранения неисправностей.');
	}

	return;
}
// Загрузка главной страницы
function load(node) {
	var intro = _Xml.child(node, 'intro');

	if (intro) {
		_Xml.fetch(intro, true);
	}

	text_transform(transformToText(node, commonXSL), 'cont');
}
function load_organization(node) {
	load(node);
}

/* BEGIN: Загрузка приложений */
function load_appendix_intro(node) {
	window['load_appendix_appendix-item'](_Xml.parent(node));
}
window['load_appendix_appendix-item'] = function(node) {
	var intro = _Xml.child(node, 'intro');

	if (intro) {
		_Xml.fetch(intro, true);
	}

	text_transform(transformToText(node, commonXSL), 'cont');
}
function load_appendix_studiedproblem(node) {
	_Xml.fetch(node, true);
	text_transform(transformToText(node, commonXSL), 'cont');
}
function load_appendix_lesson(node) {
	_Xml.fetch(node, true);
	text_transform(transformToText(node, commonXSL), 'cont');
}
/* END: Загрузка приложений */

/* BEGIN: загрузка страниц поиска и глоссария */
function load_search() {
	getSearchResults();
}
function load_glossary() {
	getGlossary();
}
/* END: загрузка страниц поиска и глоссария */

/* BEGIN: Загрузка учебных модулей */
window.load_subject = window.load_references = function(node) {
	var subjects = _Xml.collect(_Xml.parent(node), 'references subject');
	var subjectTexts = [];

	for (var i = 0; i < subjects.length; ++i) {
		_Xml.fetch(subjects[i], true);
		subjectTexts.push( transformToText(subjects[i], commonXSL) );
	}

	text_transform(subjectTexts.join(''), 'cont');
}
function load_unit(node) {
	text_transform(transformToText(node, commonXSL), 'cont');
}
function load_lesson(node) {
	text_transform(transformToText(node, commonXSL), 'cont');
}
function load_studiedproblem(node) {
	_Xml.fetch(node, true);
	text_transform(transformToText(node, commonXSL), 'cont');
}
function load_text(node) {
	_Xml.fetch(node, true);
	text_transform(transformToText(node, commonXSL, {'element-title': _Xml.title(node)}), 'cont');
}
function load_object(node) {
	text_transform(transformToText(node, commonXSL, {'element-title': _Xml.title(node)}), 'cont');
}
function load_test(node, neighbours, bypassChecks) {
	showContentLoader();

	arguments.callee.neighbours = neighbours;

	if (!bypassChecks && (
			(Test.attempted(node) && sequencingMode == 'free') ||
			(Test.passed(node) && sequencingMode == 'linear')
		)) {
		// TODO в LMS если мы уже прошли тест, то статус выставлен в completed и при перезапуске 
		// мы получим свежую порцию данных
		$('#cont')
			.html([
				'<h1 class="eAu">'+ _Xml.title(node) + get_return_link() +'</h1>',
				'<div>',
				'	<p>Вы уже прошли тест и набрали '+ format_string('процент', Test.getOption(node, 'scorePercent')) +'</p>',
				((sequencingMode == 'linear' && !DS.has('parentId'))
					? '<p>Для получения зачёта по данному тесту вам необходимо набрать '+ format_string('процент', Test.getOption(node, 'passedPC')) +'</p>'
					: ''
				),
				'	<p>Хотите заново пройти тестирование?</p>',
				'	<p><a href="index.htm" target="_top" class="eAu-test-restart" id="test-restart" onclick="return false;"><span>Пройти тест заново</span></a></p>',
				'</div>'
			].join(''));
			$('#test-restart')
				.click(function(event) {
					load_test(node, neighbours, true);
					return false;
				});
		return;
	} else if (bypassChecks) {
		$('#test-restart')
			.unbind('click');
	}

	LMS.setLessonStatus('incomplete');
	var ct = Test.newTest(node);
	ct.start();

	if (!ct.q.get('current')) {
		$('#cont')
			.html('<div class="eU-error"><h2 class="eU-error-title">Ошибка загрузки теста</h2><div class="eU-error-text">Не найдено ни одного вопроса</div></div>');
		return;
	}

	loadNavInfo(ct.q.get('current').get('xmlNode'));

	if (ct.getOption('timeLimit')) {
		arguments.callee.timer = new eAu.Timer(ct.getOption('timeLimit'), {
			finish: function() {
				// Finish test by timer
				timer_test_finish();
			},
			callback: function(duration) {
				$('#eAu-test-time').html('у вас ' + ling_format_time(duration, true) + ' до окончания тестирования');
			}
		});
	}

	load_question();
}
// Вопрос может быть загружен только из теста
// Если не передано ни одного параметра, то
// выводит вопрос на экран и устанавливает кнопки
// если нужно, то перемешивает варианты вопросов
function load_question(node, neighbours) {
	if (node) {
		load_test(_Xml.parent(node), neighbours);
		return;
	}

	showContentLoader();

	var ct = Test.getCurrent();
	var cq = ct.q.get('current');

	var random = cq.get('shuffleAnswers');

	if (/^exercise$/.test(cq.get('type'))) {
		var objectNode = _Xml.child(cq.get('xmlNode'), 'object');
		if (objectNode && !_Xml.attr(objectNode, 'eAu-exercise-dimensions-set')) {
			var exerciseCourseXml = _Xml.attr(objectNode, 'src') || '';
			exerciseCourseXml = exerciseCourseXml.split('/');
			exerciseCourseXml.pop();
			exerciseCourseXml.push('course.xml');

			// TODO: make ASYNC
			eAu.preloader.add(exerciseCourseXml.join('/'), function(data) {
				if (!data || !data.documentElement || !/^test$/.test(_Xml.name(data.documentElement))) {
					return;
				}
				var screens = _Xml.collect(data.documentElement, 'screen');
				var maxWidth = parseInt(_Xml.attr(data.documentElement, 'width'), 10);
				var maxHeight = parseInt(_Xml.attr(data.documentElement, 'height'), 10);
				for (var scrI = 0; scrI < screens.length; ++scrI) {
					var w = parseInt(_Xml.attr(screens[scrI], 'width'), 10);
					var h = parseInt(_Xml.attr(screens[scrI], 'height'), 10);
					if (w > maxWidth)  maxWidth = w;
					if (h > maxHeight) maxHeight = h;
				}
				_Xml.attr(objectNode, 'width', maxWidth ? maxWidth : '800');
				_Xml.attr(objectNode, 'height', maxHeight ? maxHeight : '600');
			});
			_Xml.attr(objectNode, 'eAu-exercise-dimensions-set', 'true');
		}
	}

	var ClonedNode = cq
		.get('xmlNode')
		.cloneNode(true);

	if (random) {
		var ClonedAnswersNode = _Xml.child(ClonedNode, 'answers');
		var childNodes = ClonedAnswersNode
			? _Xml.collect(ClonedAnswersNode, 'answer').shuffle()
			: [];
		if (ClonedAnswersNode) {
			Sarissa.clearChildNodes(ClonedAnswersNode);
		}
		for (var i = 0, length = childNodes.length; i < length; ++i) {
			ClonedAnswersNode.appendChild(childNodes[i]);
		}
	}

	ClonedNode = head
		.ownerDocument
		.createElement('fake-root')
		.appendChild(ClonedNode)
		.parentNode;

	_Xml.attr(ClonedNode, 'title', _Xml.attr(_Xml.parent(cq.get('xmlNode')), 'title'));

	text_transform(transformToText(ClonedNode, commonXSL), 'cont');

	loadTestNavInfo();

	if (cq.get('timeLimit')) {
		arguments.callee.timer = new eAu.Timer(cq.get('timeLimit'), {
			finish: function() {
				timer_question_finish();
			},
			callback: function(duration) {
				$('#eAu-question-time').html('у вас ' + ling_format_time(duration, true) + ' для ответа на вопрос');
			}
		});
	} else {
		$('#eAu-question-statistics').hide();
	}

	var serializedForm = cq.get('htmlSerializedForm');
	if (serializedForm && !/^(sort|classify)$/.test(cq.get('type'))) {
		$H(serializedForm).each(function(pair) {
			var el = $P(pair.key);
			// IE also gets element by name
			if (el && el.id == pair.key) {
				el.value = pair.value;
			} else {
				el = $P(pair.key + '-' + pair.value);
				el.checked = true;
			}
		});
	}
}
/* END: Загрузка учебных модулей */
