/* BEGIN: вспомогательные функции теста */
function restoreSortableOrder() {
	var ct = Test.getCurrent();
	var cq = ct.q.get('current');
	var serializedForm = cq.get('htmlSerializedForm');
	if (!serializedForm) {
		return;
	}
	var SortableOrder = serializedForm.split(':');
	var SortableHash = {};
	for (var i = 0, length = SortableOrder.length; i < length; ++i) {
		SortableHash[SortableOrder[i]] = document
			.getElementById(SortableOrder[i])
			.cloneNode(true);
	}

	var SortableContainer = document.getElementById('eAu-sortable-0');
	Sarissa.clearChildNodes(SortableContainer);

	for (var i = 0, length = SortableOrder.length; i < length; ++i) {
		SortableContainer.appendChild(SortableHash[SortableOrder[i]]);
	}
}
function restoreClassifyOrder() {
	var ct = Test.getCurrent();
	var cq = ct.q.get('current');
	var serializedForm = cq.get('htmlSerializedForm');
	if (!serializedForm) {
		return;
	}

	var unserializedForm = serializedForm.evalJSON();
	var SortableContainer = document.getElementById('eAu-sortable-0');
	var SortableItems = _Xml.collect(SortableContainer, 'div');
	var SortableHash = {};

	for (var i = 0, length = SortableItems.length; i < length; ++i) {
		var Id = _Xml.attr(SortableItems[i], 'id');
		SortableHash[Id] = document
			.getElementById(Id)
			.cloneNode(true);
	}

	Sarissa.clearChildNodes(SortableContainer);

	$('.eAu-sortable').each(function() {
		var c = unserializedForm[this.id];
		for (var i = 0, length = c.length; i < length; ++i) {
			this.appendChild( SortableHash[c[i]] );
		}
	});
}

$(window).bind('unload', function() {
	destroySortables();
	unloadFlashObjects();
});
function destroySortables() {
	$('.eAu-sortable').sortable('destroy');
}
function format_string_helper(N, str1, str2, str3) {
	if ( (N % 100 >= 11 && N % 100 <= 19) || (N % 10 >= 5 && N % 10 <= 9) || N % 10 == 0 ) {
		return str1;
	} else if (N % 10 == 1) {
		return str2;
	} else {
		return str3;
	}
}
function format_string(str, N) {
	var origN = N;
	N = Math.floor(N);
	var strFormated = '';
	if (str == 'балл') {
		strFormated = format_string_helper(N, 'баллов', 'балл', 'балла');
	} else if (str == 'процент') {
		strFormated = format_string_helper(N, 'процентов', 'процент', 'процента');
	} else if (str == 'возможность') {
		strFormated = format_string_helper(N, 'возможных', 'возможного', 'возможных');
	} else if (str == 'вопрос') {
		strFormated = format_string_helper(N, 'вопросов', 'вопрос', 'вопроса');
	}
	return  origN + ' ' + strFormated;
}
function ling_format_time(time, left) {
	var N = Math.floor(time / 1000 / 60);
	if (N == 0) {
		N = Math.floor(time / 1000);
		var NStr = '<span class="eAu-timer-stat">' + N + '</span>';
		if ( (N % 100 >= 11 && N % 100 <= 19) || (N % 10 >= 5 && N % 10 <= 9) || N % 10 == 0 ) {
			return (left ? 'осталось ' : 'прошло ')+ NStr +' секунд';
		} else if (N % 10 == 1) {
			return (left ? 'осталась ' : 'прошла ')+ NStr +' секунда';
		} else {
			return (left ? 'осталось ' : 'прошло ')+ NStr +' секунды';
		}
	} else {
		var NStr = '<span class="eAu-timer-stat">' + N + '</span>';
		if ( (N % 100 >= 11 && N % 100 <= 19) || (N % 10 >= 5 && N % 10 <= 9) || N % 10 == 0 ) {
			return (left ? 'осталось ' : 'прошло ')+ NStr +' минут';
		} else if (N % 10 == 1) {
			return (left ? 'осталась ' : 'прошла ')+ NStr +' минута';
		} else {
			return (left ? 'осталось ' : 'прошло ')+ NStr +' минуты';
		}
	}
}
function get_return_link() {
	return (DS.has('parentId')
	  ? '<a href="index.htm" onclick="link_info(\''+ DS.get('parentId') +'\'); return false;" target="_top" title="Вернуться к основному содержимому"><img border="0" src="images/return.gif" width="18" height="18" align="absmiddle" hspace="7" /></a>'
	  : ''
	);
}
function loadTestNavInfo() {
	setButton();

	var ct = Test.getCurrent();
	var cq = ct.q.get();
	var isLast = ct.q.isLast();

	$(document).trigger('node:changed');

	// Получаем ноду с заголовком вопроса
	// jQuery не справляется с id'шниками типа #id-{AAA}
	var headerNode = document.getElementById('eAu-question-title-'+ cq.get('id'));
	if (headerNode) {
		headerNode = $(headerNode);
		var qTitle = (_Xml.attr(cq.get('xmlNode'), 'title') || '').norm().trim();
		var qTitleRegExp = /^(Вопрос|Question)( (N|#|№)?[0-9]*)?$/i;
		if (qTitleRegExp.test(qTitle)) {
			var text = qTitle.match(qTitleRegExp)[1];
			headerNode.text(text + ' ' + (/[A-Za-z]/.test(text.charAt(0)) ? '#' : '№') + ct.q.getPosition());
		}
	}

	if (!cq.get('group') && !cq.get('timeLimit')) {
		$('#eAu-question-statistics').hide();
	}

	$('#eAu-test-questions-statistics').html('осталось вопросов &ndash; <span class="eAu-test-questions-left">'+ ct.q.getLeft() +'</span>, вопросов всего &ndash; <span class="eAu-test-questions-all">'+ ct.q.getLength() +'</span>');

	if (ct.getOption('allowTestSkip')) {
		$('#eAu-test-end').show();
	}

	if (ct.getOption('navigationMode') == 2 && !isLast) {
		setButton('next-question', function() { skip_question(); return false; }, 'Пропустить вопрос');
	}

	if (ct.getOption('navigationMode') == 1 && ct.q.get('previous')) {
		setButton('previous-question', function() { previous_question(); return false; }, 'Вернуться к предыдущему вопросу');
	} else if (ct.q.isFirst() && checkRights(load_test.neighbours.prev) && canNavigateToNodeOnServer(load_test.neighbours.prev)) {
		setButton('previous', function() { link_info(_Xml.id(load_test.neighbours.prev)); }, _Xml.title(load_test.neighbours.prev));
	}

	setButton('answer-question', function() { check_question(); return false; }, isLast ? 'Ответить и завершить тестирование' : 'Ответить');
}
function interrupt_question_timer() {
	if (load_question.timer) {
		load_question.timer.interrupt();
		load_question.timer = null;
	}
}
function interrupt_test_timer() {
	if (load_test.timer) {
		load_test.timer.interrupt();
		load_test.timer = null;
	}
}
// Завершить тестирование нормальным образом
function finish_test(finishMode) {
	interrupt_question_timer();
	interrupt_test_timer();

	setButton();

	var ct = Test.getCurrent();
	var cq = ct.q.get();

	finishMode = finishMode || 1;

	ct.finish(finishMode);

	if (finishMode == 2) {
		return;
	}
	
	var result = ct.score(finishMode != 3);
	if (finishMode != 3) {
		if (!DS.has('parentId')) {
			LMS.setScoredLessonData(result.raw, result.min, result.max);
			LMS.setLessonStatus(ct.passed() ? 'passed' : 'failed');
		}
	}

	destroySortables();
	unloadFlashObjects();

	$(document).trigger('test:passed');

	var neighbours = loadNavInfo(ct.getTestNode());

	var testFinishHeader = '<h1 class="eAu">Тестирование '+ (finishMode != 3 ? 'завершено' : 'прервано') + get_return_link() +'</h1>';
	var testStatString = (ct.getOption('showTestStats') && finishMode != 3)
		? [
			'<p>Было набрано '+ format_string('балл', result.raw) +' из '+ format_string('возможность', result.max) +' ('+ result.percent +'%)</p>',
			'<p>Ответы даны на '+ format_string('вопрос', result.q.answered) + ' из '+ result.q.total +'</p>'
		  ].join('\n')
		: finishMode != 3
			? [
				'<p>Оценка за тестирование была выставлена</p>',
				'<p>Вами набрано '+ result.percent +'%</p>'
			  ].join('\n')
			: '<p>Оценка за тестирование не была выставлена</p>';
	var testRestartOrContinueString = (sequencingMode == 'linear' && !DS.has('parentId'))
		? (ct.passed()
			? '<p>Вами набрано достаточное количество баллов для продолжения обучения<p>'
			: [
				'<p>Набранного балла недостаточно для продолжения обучения</p>',
				'<p><a href="index.htm" target="_top" class="eAu-test-restart" id="test-restart" onclick="return false;">',
				'	<span>Пройти тест заново</span>',
				'</a></p>'
			  ].join('\n')
		  )
		: '<p>Вы можете продолжить обучение</p>';

	$('#cont')
		.html([
			'<div class="eAu-test-statistic">',
				testFinishHeader,
			'	<div class="eAu-test-statistic-text">',
					testStatString,
					testRestartOrContinueString,
			'	</div>',
			'</div>'
		].join(''));

	if (ct.passed()) {
		LMS.terminate();
	}

	$('#test-restart')
		.click(function(event) {
			load_test(ct.getTestNode(), neighbours, true);
			return false;
		});
}
// Прервать тестирование
function break_test() {
	finish_test(3);
}
// Досрочно завершить тестирование с выставлением оценки
function end_test() {
	if (!Test.getCurrent().getOption('allowTestSkip')) { return; }

	finish_test(4);
}
// Тестирование завершено по истечении отведённого времени
function timer_test_finish() {
	finish_test(5);
}
// Пропустить вопрос
function skip_question() {
	// Переформировать очередь
	// выполнить load_question
	interrupt_question_timer();
	Test.getCurrent().q.skip();
	load_question();
}
// Перейти к предыдущему вопросу
function previous_question() {
	interrupt_question_timer();
	Test.getCurrent().q.previous();
	load_question();
}
function next_question() {
	Test.getCurrent().q.next();
	load_question();
}
// учащийся не успел ответить на вопрос
function timer_question_finish() {
	check_question();
}
function score_question() {
	var score = 0;
	var userAnswers = {};
	var rightAnswers = {};

	var ct = Test.getCurrent();
	var cq = ct.q.get();

	var questionType = cq.get('type');
	var node = cq.get('xmlNode');

	var AnswersNode = _Xml.child(node, 'answers');
	var answers = /^(exercise)$/.test(questionType) || !AnswersNode
		? []
		: _Xml.collect(AnswersNode, 'answer');

	var scoreMin = cq.get('scoreMin');
	var scoreMax = cq.get('scoreMax');
	var origScoreMin = scoreMin;

	// Нормализуем промежуток что-бы он лежал в пределах
	// от нуля до ...
	scoreMax = scoreMax - origScoreMin;
	scoreMin = 0;

	var scoreByWeights = cq.get('scoreByWeights');

	var tryesCount = cq.get('tryesCount') + 1;

	if (!/^(exercise)$/.test(questionType) && !answers.length) {
		return {
			score: score,
			userAnswers: userAnswers,
			rightAnswers: rightAnswers
		};
	}

	var retValue = {};
	if (/^compare$/.test(questionType)) {
		var RightAnswersCount = 0;
		var AnswerWeights = 0;
		for (var i = 0; i < answers.length; ++i) {
			var answerId = _Xml.id(answers[i]);
			var answerNode = document.getElementById('EU-'+ answerId);
			var userAnswer = $(answerNode.options[answerNode.selectedIndex]).attr('val');
			var rightAnswer = _Xml.attr(answers[i], 'right');
			if (answerNode.selectedIndex >= 0 && (rightAnswer == userAnswer)) {
				RightAnswersCount++;
			}
			userAnswers[answerId] = userAnswer;
			rightAnswers[answerId] = rightAnswer;
		}
		score = (answers.length == 0)
			? 0
			: scoreMax * parseFloat(RightAnswersCount) / parseFloat(answers.length);
	} else if (/^fill$/.test(questionType)) {
		var RightAnswersCount = 0;
		for (var i = 0; i < answers.length; ++i) {
			var answerId = _Xml.id(answers[i]);
			var answerNode = document.getElementById('EU-'+ answerId);
			var userAnswer = (answerNode.value || '').strip().norm();
			var rightAnswer = (_Xml.attr(answers[i], 'right') || '').trim();
			rightAnswer = rightAnswer
				.split('|')
				.map(function(val) {
					return val.trim().norm().toLowerCase();
				})
				.without('');
			if (rightAnswer.length == 0) {
				rightAnswer.push('');
			}
			if (rightAnswer.indexOf(userAnswer.toLowerCase()) != -1) {
				RightAnswersCount++;
			}
			userAnswers[answerId] = userAnswer;
			rightAnswers[answerId] = rightAnswer;
		}
		score = (answers.length == 0)
			? 0
			: scoreMax * parseFloat(RightAnswersCount) / parseFloat(answers.length);
	} else if (/^(single|multiple)$/.test(questionType)) {
		var AnswersCount = {
			right: { checked: 0, unchecked: 0, all: 0 },
			wrong: { checked: 0, unchecked: 0 }
		};
		var AnswerWeights = 0;
		for (var i = 0; i < answers.length; ++i) {
			var answerId = _Xml.id(answers[i]);
			var answerNodeId = 'EU-' + cq.get('id') + '-' + answerId + (questionType == 'single' ? '' : '-1');
			var answerNode = document.getElementById(answerNodeId);
			var weight = parseInt(_Xml.attr(answers[i], 'weight'), 10) || 0;
			var userAnswer = answerNode.checked;
			var rightAnswer = _Xml.attr(answers[i], 'type') == 'true' ? true : false;

			if (rightAnswer == true) {
				AnswersCount.right.all += 1;
				userAnswer == true ? ++AnswersCount.right.checked : ++AnswersCount.right.unchecked;
			} else {
				userAnswer == true ? ++AnswersCount.wrong.checked : ++AnswersCount.wrong.unchecked;
			}
			userAnswers[answerId] = userAnswer;
			rightAnswers[answerId] = rightAnswer;
			if (userAnswer) {
				AnswerWeights += weight;
			}
		}
		if (!scoreByWeights) {
			if (/^multiple$/.test(questionType)) {
				var a = AnswersCount;
				var ar = AnswersCount.right;
				var aw = AnswersCount.wrong;

				score = (answers.length == 0)
					? 0
					: parseFloat(scoreMax)
						* (parseFloat(ar.checked + aw.unchecked - ar.unchecked - aw.checked)
							/ parseFloat(answers.length)
							/ 2.0
							+ 0.5
						);
			} else {
				if (AnswersCount.right.all == 0) {
					score = AnswersCount.wrong.checked == 0 ? scoreMax : scoreMin;
				} else {
					score = AnswersCount.right.checked == 1 ? scoreMax : scoreMin;
				}
			}
		} else {
			score = AnswerWeights;
		}
	} else if (/^sort$/.test(questionType)) {
		var SortableOrder = $('#eAu-sortable-0').sortable('toArray');
		var RightAnswersCount = 0;
		var sortableRightOrder = [];
		for (var i = 0; i < answers.length; ++i) {
			var answerId = _Xml.id(answers[i]);
			var userAnswer = SortableOrder[i];
			var rightAnswer = 'EU-' + answerId;
			sortableRightOrder.push(rightAnswer);
			if (rightAnswer == userAnswer) {
				RightAnswersCount++;
			}
			userAnswers[answerId] = userAnswer;
			rightAnswers[answerId] = rightAnswer;
		}
		score = (answers.length == 0)
			? 0
			: scoreMax * parseFloat(RightAnswersCount) / parseFloat(answers.length);
		retValue.sortableRightOrder = sortableRightOrder;
	} else if (/^classify$/.test(questionType)) {
		var RightAnswersCount = 0;
		var SortableOrder = {};
		var SortableOrderHash = {};
		$('.eAu-sortable').each(function() {
			if (this.id == 'eAu-sortable-0') { return; }
			var $this = $(this);
			var tmp = $this.sortable('toArray');
			SortableOrder[$this.attr('group')] = tmp;
			for (var i = 0; i < tmp.length; ++i) {
				SortableOrderHash[tmp[i]] = $this.attr('group');
			}
		});

		for (var i = 0; i < answers.length; ++i) {
			var answerId = _Xml.id(answers[i]);
			var userAnswer = SortableOrderHash['EU-' + answerId];
			var rightAnswer = _Xml.attr(answers[i], '__eAu-class-group');
			if (!Object.isUndefined(userAnswer) && rightAnswer == userAnswer) {
				RightAnswersCount++;
			}
			userAnswers[answerId] = userAnswer;
			rightAnswers[answerId] = rightAnswer;
		}
		score = (answers.length == 0)
			? 0
			: scoreMax * parseFloat(RightAnswersCount) / parseFloat(answers.length);
	} else if (/^exercise$/.test(questionType)) {
		var node = _Xml.child(cq.get('xmlNode'), 'object');
		if (node && question_exercise_get_flash_loaded(_Xml.id(node))) {
			var safeId = object_generate_id(node);
			var flashNode = document.getElementById(safeId);
			var flScore = {
				raw: parseFloat(flashNode.callMethod('getValue', 'score.raw'), 10),
				min: parseFloat(flashNode.callMethod('getValue', 'score.min'), 10),
				max: parseFloat(flashNode.callMethod('getValue', 'score.max'), 10),
				errors: parseInt(flashNode.callMethod('getValue', 'errors.raw'), 10),
				comletion_status: flashNode.callMethod('getValue', 'completion_status')
			};
			score = flScore.comletion_status == 'completed' && ((flScore.max - flScore.min) != 0)
				? scoreMax * ((flScore.raw - flScore.min) / (flScore.max - flScore.min))
				: 0;
		} else {
			score = scoreMax * (ct.getOption('passedPC') / 100.0);
		}
	}
	score += origScoreMin;

	Object.extend(retValue, {
		score: score,
		userAnswers: userAnswers,
		rightAnswers: rightAnswers
	});
	return retValue;
}
// Учащийся ответил на вопрос, засчитать попытку
function check_question() {
	interrupt_question_timer();

	var ct = Test.getCurrent();
	var cq = ct.q.get();
	var node = cq.get('xmlNode');
	var questionType = cq.get('type');

	var result = score_question();

	if (/^sort$/.test(questionType)) {
		cq.set('htmlSerializedForm', $('#eAu-sortable-0').sortable('toArray').join(':'));
	} else if (/^classify$/.test(questionType)) {
		var SortableHash = {};
		$('.eAu-sortable').each(function() {
			SortableHash[this.id] = $(this).sortable('toArray');
		});
		cq.set('htmlSerializedForm', Object.toJSON(SortableHash));
	} else if ($P('eAu-question-form')) {
		cq.set('htmlSerializedForm', $P('eAu-question-form').serialize(true));
	}

	destroySortables();
	unloadFlashObjects();

	cq.set('score', result.score);

	var showRightAnswers = ct.getOption('showRightAnswers');
	var showTestStats = ct.getOption('showTestStats');

	var IsLast = ct.q.isLast();

	setButton();

	$(document).trigger('test:question:answered', [result, cq, ct]);

	if (IsLast) {
		if (showRightAnswers) {
			setTimeout(function() {
				setButton('next-question', function() { finish_test(); }, 'Окончить тестирование');
			}, 250);
		} else {
			finish_test();
			return;
		}
	} else {
		if (showRightAnswers) {
			setTimeout(function() {
				setButton('next-question', function() {
					next_question();
				}, 'К следующему вопросу');
			}, 250);
		} else {
			next_question();
			return;
		}
	}

	// Нужно показать правильные ответы
	// Проверять переменную showRightAnswers не имеет смыслы, иначе мы-бы уже
	// любовались другим вопросом или статистикой за тест
	if (!cq.get('scoreByWeights')) {
		var title = '<h2 class="eAu">Вы ответили на вопрос</h2>';
		var AnswersNode = _Xml.child(node, 'answers');
		var comments = cq.get('comments');
		var commentsText = '';
		if (comments.length && result.score < cq.get('scoreMax')) {
			commentsText = ['<div class="eAu-question-comments">'];
			commentsText.push('<div class="eAu-question-comments-title"><h3 class="eAu">Комментарии:</h3></div>');
			for (var i = 0; i < comments.length; ++i) {
				commentsText.push('<div class="eAu-question-comment">'+ getNodeText(comments[i]) +'</div>')
			}
			commentsText.push('</div>');
			commentsText = text_transform(commentsText.join(''));
		}

		var answers = AnswersNode
			? _Xml.collect(AnswersNode, 'answer')
			: [];

		var nodeWithAnswers = !/^exercise$/.test(questionType)
			? document.getElementById('eAu-question-answers')
			: { innerHTML: '' };

		result.score = Math.floor(result.score * 100) / 100;
		var scoreText = '<p>и набрали '+ format_string('балл', result.score) +' из '+ format_string('возможность', cq.get('scoreMax')) +'</p>';
		$('#cont').html(title + scoreText +'<div class="eAu-question-answers">' + nodeWithAnswers.innerHTML + '</div>' + commentsText);
		for (var i = 0; i < answers.length; ++i) {
			var answerId = _Xml.id(answers[i]);
			var answerNodeId = 'EU-' + (/^(single|multiple)$/.test(questionType) ? cq.get('id') + '-' : '') + answerId + (/^multiple$/.test(questionType) ? '-1' : '');
			var answerNode = document.getElementById(answerNodeId);
			var tdForRightAnswer = document.getElementById('EU-RA-' + answerId);
			var tr = answerNode ? _Xml.parentOrSelf(answerNode, 'tr') : null;
			
			if (/^(multiple|single)$/.test(questionType)) {
				answerNode.checked = result.userAnswers[answerId];
				answerNode.disabled = true;
				if (answerNode.checked && result.userAnswers[answerId] != result.rightAnswers[answerId]) {
					$(_Xml.parent(answerNode, 'td'))
						.addClass('eAu-checkbox-wrong-user-answer');
				} else if (answerNode.checked) {
					$(_Xml.parent(answerNode, 'td'))
						.addClass('eAu-checkbox-right-user-answer');
				}
				if (result.rightAnswers[answerId]) {
					$(tr).addClass('eAu-right-user-answer'); 
				}
			} else if (/^fill$/.test(questionType)) {
				answerNode.value = result.userAnswers[answerId];
				_Xml.attr(answerNode, 'readonly', 'readonly');
				if (result.rightAnswers[answerId].indexOf(result.userAnswers[answerId].toLowerCase()) == -1) {
					$(tr).addClass('eAu-wrong-user-answer');
					$(tdForRightAnswer).html('<div>'+ result.rightAnswers[answerId].join(' <i class="eAu-fill-or">или</i> ') +'</div>');
				} else {
					$(tr).addClass('eAu-right-user-answer');
				}
			} else if (/^compare$/.test(questionType)) {
				$(answerNode.parentNode).html('<select id="EU-'+ answerId +'" class="eAu-input-text"><option>'+ result.userAnswers[answerId] +'</option></select>');
				answerNode = document.getElementById('EU-' + answerId);
				answerNode.disabled = true;
				if (result.rightAnswers[answerId] != result.userAnswers[answerId]) {
					$(tr).addClass('eAu-wrong-user-answer');
					$(tdForRightAnswer).html('<div>'+ result.rightAnswers[answerId] +'</div>');
				} else {
					$(tr).addClass('eAu-right-user-answer');
				}
			} else if (/^sort$/.test(questionType)) {
				if (result.rightAnswers[answerId] == result.userAnswers[answerId]) {
					$(answerNode).addClass('eAu-right-user-answer');
				} else {
					$(answerNode).addClass('eAu-wrong-user-answer');
				}
				$(tdForRightAnswer).html('<div>'+ (result.sortableRightOrder.indexOf(result.rightAnswers[answerId]) + 1) +'</div>');
			} else if (/^classify$/.test(questionType)) {
				if (!Object.isUndefined(result.userAnswers[answerId]) && result.rightAnswers[answerId] == result.userAnswers[answerId]) {
					$(answerNode).addClass('eAu-right-user-answer');
				} else {
					$(answerNode).addClass('eAu-wrong-user-answer');
					$(tdForRightAnswer).html('<div>' + (_Xml.attr(answers[i], 'class-group') || '<i>Категория без имени</i>').strip().norm() + '</div>');
				}
			}
		}
	} else if (cq.get('scoreByWeights')) {
		$('#cont').html('<h2 class="eAu">Вопрос оценивается по весам</h2>');
	}
	$('#content').scrollTop(0);
}
/* END: вспомогательные функции теста */
