function toggleElementVisibility(element) {
	element = $(element);
	var ElementLeft = parseInt(element.css('left'), 10);
	var isElementVisible = isNaN(ElementLeft) || ElementLeft >= -3333;

	if (isElementVisible) {
		hideElement(element);
	} else {
		showElement(element);
	}

	return !isElementVisible;
}
function hideElement(element) {
	element = $(element);
	var ElementLeft = parseInt(element.css('left'), 10);
	var isElementVisible = isNaN(ElementLeft) || ElementLeft >= -3333;
	if (!isElementVisible) {
		return;
	}

	element.css({
		'left': -30000,
		'right': 'auto'
	});
	element.trigger('eAu:ui:popup:move', {
		x: -30000,
		oldX: ElementLeft,
		width: element.outerWidth(true),
		height: element.outerHeight(true) - 8
	});
}
function showElement(element) {
	element = $(element);
	var ElementLeft = parseInt(element.css('left'), 10);
	var isElementVisible = isNaN(ElementLeft) || ElementLeft >= -3333;
	if (isElementVisible) {
		return;
	}

	element.css({
		'left': -3000,
		'right': 'auto'
	});
	element.trigger('eAu:ui:popup:move', {
		x: -3000,
		oldX: ElementLeft,
		width: element.outerWidth(true),
		height: element.outerHeight(true) - 8
	});
}
function isElementVisible(element) {
	var ElementCssLeft =   parseInt(element.css('left'), 10);
	return isNaN(ElementCssLeft) || ElementCssLeft >= -3333;
}
var Resizers = (function() {
	var _Resizers = {}; // Список всех функций, контролирующих размер
	var _ResizersOrder = [];
	var _ElementsCache = {};

	$(window).bind('unload', function() {
		for (var item in _ElementsCache) {
			delete _ElementsCache[item];
		}
	});

	var cache = {
		get: function(id) {
			_ElementsCache[id] = _ElementsCache[id]
				? _ElementsCache[id]
				: $(id);

			return _ElementsCache[id];
		}
	}
	
	return {
		resize: function(event, itemId) {
			var viewport = {
				height: $(window).height(),
				width: $(window).width()
			}

			if (itemId && _Resizers[itemId]) {
				_Resizers[itemId](event, cache, viewport);
				return;
			}
			for (var i = 0, length = _ResizersOrder.length; i < length; ++i) {
				_Resizers[_ResizersOrder[i]](event, cache, viewport);
			}
		},
		add: function(itemId, resizeFunction) {
			if (!$.isFunction( resizeFunction )) {
				throw "Invalid resize handler";
			}
			if (!itemId || typeof itemId != 'string') {
				throw "Invalid handler id";
			}
			if (_Resizers[itemId]) { return false; }
			_Resizers[itemId] = resizeFunction;
			_ResizersOrder.push(itemId);
			return true;
		}
	};
})();

Resizers.add('breadedcrumbs', function(event, ec, vp) {
	var menu          = ec.get('#menu');
	var layoutHeader  = ec.get('#layout-header');
	var breadedCrumbs = ec.get('#breaded-crumbs');
	
	var minContentWidth = 424;
	
	var isMenuPositionStatic = $(document.body)
		.is('.menu-layout-static');
	
	var LayoutHeaderHeight = layoutHeader.is(':visible')
		? layoutHeader.height()
		: 0;
	var menuWidth = isMenuPositionStatic
		? menu.width()
		: 0;
	var BreadedCrumbsWidth = vp.width - menuWidth;
	BreadedCrumbsWidth = BreadedCrumbsWidth >= minContentWidth
		? BreadedCrumbsWidth
		: minContentWidth;
	
	var BCLeft = menuWidth;
	var BCTop  = LayoutHeaderHeight;
	
	var BCCss = {};
	if (parseInt(breadedCrumbs.css('width'), 10) != BreadedCrumbsWidth) {
		BCCss.width = BreadedCrumbsWidth;
	}
	if (parseInt(breadedCrumbs.css('top'), 10) != BCTop) {
		BCCss.top = BCTop;
	}
	if (parseInt(breadedCrumbs.css('left'), 10) != BCLeft) {
		BCCss.left = BCLeft;
	}
	
	breadedCrumbs.css(BCCss);
});

Resizers.add('content', function(event, ec, vp) {
	var content       = ec.get('#content');
	var menu          = ec.get('#menu');
	var layoutBody    = ec.get('#layout-body');
	var layoutHeader  = ec.get('#layout-header');
	var layoutBottom  = ec.get('#layout-bottom');
	var breadedCrumbs = ec.get('#breaded-crumbs');

	var minContentHeight = 55;
	var minContentWidth = 424; // Ширина 2-х панелей кнопок справа и слева по 105
	                           // + кнопки навигации 2 * 70
	                           // + padding у тулбара 2 * 20
	                           // + 2 * 17 для 2-х элементов слайдера (минимум)

	var isMenuPositionStatic = $(document.body)
		.is('.menu-layout-static');

	var LayoutHeaderHeight = layoutHeader.is(':visible')
		? layoutHeader.height()
		: 0;
	var LayoutBottomHeight = layoutBottom.height();
	var BreadedCrumbsHeight = breadedCrumbs.is(':visible')
		? breadedCrumbs.height()
		: 0;
	var menuWidth = isMenuPositionStatic
		? menu.width()
		: 0;

	var ContentWidth = vp.width - menuWidth;
	var ContentHeight = vp.height
		- LayoutHeaderHeight
		- LayoutBottomHeight
		- BreadedCrumbsHeight;
	ContentHeight = ContentHeight >= minContentHeight
		? ContentHeight
		: minContentHeight;
	ContentWidth = ContentWidth >= minContentWidth
		? ContentWidth
		: minContentWidth;

	var ContentCss = {};
	if (parseInt(content.css('width'), 10) != ContentWidth) {
		ContentCss.width = ContentWidth;
	}
	if (parseInt(content.css('height'), 10) != ContentHeight) {
		ContentCss.height = ContentHeight;
	}

	var LayoutBodyTop = LayoutHeaderHeight + BreadedCrumbsHeight;
	var LayoutBodyLeft = menuWidth;
	var LayoutBodyCss = {};
	if (parseInt(layoutBody.css('top'), 10) != LayoutBodyTop) {
		LayoutBodyCss.top = LayoutBodyTop;
	}
	if (parseInt(layoutBody.css('left'), 10) != LayoutBodyLeft) {
		LayoutBodyCss.left = LayoutBodyLeft;
	}

	content
		.css(ContentCss);
	layoutBody
		.css(LayoutBodyCss);
});
Resizers.add('bottom', function(event, ec, vp) {
	var content      = ec.get('#content');
	var layoutBottom = ec.get('#layout-bottom');

	var isMenuPositionStatic = $(document.body)
		.is('.menu-layout-static');

	var ContentWidth             = content.width();
	var CurrentLayoutBottomWidth = layoutBottom.width();

	var LayoutBottomCss = {};
	if (CurrentLayoutBottomWidth != ContentWidth && ContentWidth > 0) {
		LayoutBottomCss.width = ContentWidth;
	}

	layoutBottom.css(LayoutBottomCss);
});
Resizers.add('menu', function(event, ec, vp) {
	var menu   = ec.get('#menu');
	var offset = 5;

	var isMenuPositionStatic = $(document.body)
		.is('.menu-layout-static');

	if (!isMenuPositionStatic || !isElementVisible(menu)) {
		resizePopup(menu, ec, vp, {
			snapTo: 'bottom left',
			hoffset: 21,
			vstemoffset: offset,
			voffset: offset
		});
		return;
	}

	var menuHeader    = ec.get('#menu-header');
	var menuContent   = ec.get('#menu-content');
	var menuOverflow  = ec.get('#menu-overflow');

	menuOverflow.css('overflow', 'hidden');

	var layoutHeaderHeight = ec.get('#layout-header').is(':visible')
		? ec.get('#layout-header').height()
		: 0;
	var breadedCrumbsHeight = ec.get('#breaded-crumbs').is(':visible')
		? ec.get('#breaded-crumbs').height()
		: 0;
	var contentHeight = ec.get('#content').height();
	var layoutBottomHeight = ec.get('#layout-bottom').is(':visible')
		? ec.get('#layout-bottom').height()
		: 0;

	var menuHeaderHeight = menuHeader.is(':visible')
		? menuHeader.height()
		: 0;
	var menuContentHeight = menuContent.outerHeight(true);
	var menuBottomPadding = (parseInt(menuOverflow.parent().css('padding-bottom'), 10) || 0);

	var menuHeight = contentHeight
		+ breadedCrumbsHeight
		+ layoutBottomHeight
		- menuBottomPadding
		- menuHeaderHeight;

	var menuTop = layoutHeaderHeight;
	var menuLeft = 0;

	var menuCss = {};
	var menuOverflowCss = {};
	var moveEvent = {
		oldY: parseInt(menu.css('top'), 10),
		oldX: parseInt(menu.css('left'), 10)
	};
	if (parseInt(menu.css('top'), 10) != menuTop) {
		menuCss.top = menuTop;
		moveEvent.y = menuTop;
	}
	if (parseInt(menu.css('left'), 10) != menuLeft) {
		menuCss.left = menuLeft;
		moveEvent.x = menuLeft;
	}
	if (parseInt(menuOverflow.css('height'), 10) != menuHeight && menuHeight > 0) {
		menuOverflowCss.height = menuHeight;
	}

	menuOverflow.css('overflow', 'auto');
	menu.css(menuCss);
	menuOverflow.css(menuOverflowCss);
	moveEvent.width = menu.outerWidth(true);
	moveEvent.height = menu.outerHeight(true);
	menu.trigger('eAu:ui:popup:move', moveEvent);
});
Resizers.add('popups', function(event, ec, vp) {
	resizePopup(ec.get('#help'), ec, vp);
	resizePopup(ec.get('#mode'), ec, vp, { hoffset: 56 });
	resizePopup(ec.get('#bookmarks'), ec, vp, { hoffset: 91 });
});
function resizePopup(element, ec, vp, options) {
	options = $.extend({
		snapTo: 'bottom right',
		hoffset: 21,
		vstemoffset: 5,
		voffset: 5
	}, options || {});

	if (!isElementVisible(element)) {
		return;
	}
	var elementId  = element.attr('id');
	var stemHeight = 8;
	var offset     = options.vstemoffset;
	var vSnap = ((options.snapTo || '').split(/\s+/)[0]) || 'bottom';
	var hSnap = ((options.snapTo || '').split(/\s+/)[1]) || 'right';

	var elementOverflow = ec.get('#'+ elementId +'-overflow');
	var elementContent  = ec.get('#'+ elementId +'-content');

	elementOverflow.css('overflow', 'hidden');

	// BEGIN: Root layout dimensions
	var layoutHeaderHeight = ec.get('#layout-header').is(':visible')
		? ec.get('#layout-header').height()
		: 0;
	var breadedCrumbsHeight = ec.get('#breaded-crumbs').is(':visible')
		? ec.get('#breaded-crumbs').height()
		: 0;
	var contentHeight = ec.get('#content').height();
	var layoutBottomHeight  = ec.get('#layout-bottom').is(':visible')
		? ec.get('#layout-bottom').height()
		: 0;
	// END: Root layout dimensions

	// BEGIN: POPUP Dimensions
	var elementHeaderHeight = ec.get('#'+ elementId +'-header').is(':visible')
		? ec.get('#'+ elementId +'-header').height()
		: 0;
	var elementContentHeight = elementContent.outerHeight(true);
	var elementBottomPadding = (parseInt(elementOverflow.parent().css('padding-bottom'), 10) || 0);
	var elementWidth = element.width();
	var elementHeight = contentHeight
		- elementHeaderHeight
		- elementBottomPadding
		- stemHeight
		- offset
		- (options.voffset > 0 ? options.voffset : 0);
	// END: POPUP Dimensions

	// BEGIN: Dimension corrections
	var diff = (elementHeight - elementContentHeight) < 0
		? 0
		: elementHeight - elementContentHeight;
	elementHeight = elementHeight > elementContentHeight
		? elementContentHeight
		: elementHeight;
	// END: Dimension corrections

	// BEGIN: POPUP Position
	var elementTop = 0;
	if (vSnap == 'bottom') {
		elementTop = layoutHeaderHeight
			+ breadedCrumbsHeight
			+ diff
			+ (options.voffset > 0 ? options.voffset : 0);
	}
	var elementLeft = 0;
	if (hSnap == 'right') {
		elementLeft = vp.width - elementWidth - options.hoffset;
	} else if (hSnap == 'left') {
		elementLeft = options.hoffset;
	}
	// END: POPUP Position

	// BEGIN: calculation diff
	var elementCss = {};
	var elementOverflowCss = {};
	var moveEvent = {
		oldY: parseInt(element.css('top'), 10),
		oldX: parseInt(element.css('left'), 10)
	};
	if (parseInt(element.css('top'), 10) != elementTop) {
		elementCss.top = elementTop;
		moveEvent.y = elementTop;
	}
	if (parseInt(element.css('left'), 10) != elementLeft) {	
		elementCss.left = elementLeft;
		moveEvent.x = elementLeft;
	}
	if (parseInt(elementOverflow.css('height'), 10) != elementHeight) {
		elementOverflowCss.height = elementHeight;
	}
	// END: calculation diff

	elementOverflow.css('overflow', 'auto');
	element.css(elementCss);
	elementOverflow.css(elementOverflowCss);
	moveEvent.width = element.outerWidth(true);
	moveEvent.height = element.outerHeight(true) - stemHeight;
	element.trigger('eAu:ui:popup:move', moveEvent);
}

function moveIframeShim(element, moveEvent) {
	element = $(element);
	var iframeId = element.attr('iframeshimid');

	if (!iframeId) {
		return;
	}

	// Зачем двигать что-то в темноте
	if (moveEvent.oldX < 0 && moveEvent.x < 0) {
		return;
	}

	var iframe = $('#' + iframeId);

	if (!iframe.length) {
		return;
	}

	var iframeCss = { };
	if (moveEvent.width >= 0 && moveEvent.height >= 0) {
		iframeCss.width = moveEvent.width;
		iframeCss.height = moveEvent.height;
	}
	if (!Object.isUndefined(moveEvent.x) && !isNaN(moveEvent.x)) {
		iframeCss.left = moveEvent.x;
	}
	if (!Object.isUndefined(moveEvent.y) && !isNaN(moveEvent.y)) {
		iframeCss.top = moveEvent.y;
	}

	iframe.css(iframeCss);
}

// Добавим iframe shim к каждому попапу
$(function(event) {
	var iframeTemplate = new Template([
		'<iframe',
		'	class="popup-iframe-shim"',
		'	id="#{id}"',
		'	style="',
		'		position: absolute;',
		'		opacity: 0;',
		'		left: -30000px;',
		'		z-index: #{z-index};',
		'		filter: progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=0);',
		'	"',
		'	src="javascript:false;"',
		'	frameBorder="0"',
		'	scrolling="no"',
		'></iframe>'
	].join(' '));

	$(".popup")
		.each(function(i) {
			var $this = $(this);
			if ($this.attr('iframeshimid')) {
				return;
			}

			var zIndex = parseInt($this.css('z-index'), 10) || 0;
			$this.attr('iframeshimid', 'eAu-iframe-shim-' + i);
			var iframeText = iframeTemplate.evaluate({
				'z-index': zIndex - 1,
				'id': 'eAu-iframe-shim-' + i
			});
			$this.after(iframeText);

			// Мерзкий хак для IE
			if (this.insertAdjacentHTML) {
				$('#content').scroll(function() {
					var element = $('#eAu-iframe-shim-' + i);
					if (!isElementVisible(element)) {
						return;
					}

					$this.css('z-index', zIndex - 1)
					$this.css('z-index', zIndex)
				});
			}
		})
		.bind('eAu:ui:popup:move', function(event, moveEvent) {
			moveEvent.wrappedEvent = event;
			moveIframeShim(this, moveEvent);
		});
});

$(function() {
	$('.toolbar .button')
		.addClass('button-hidden');
});
