eAu.$break = {};

(function() {

if (!eAu) { self.eAu = {}; }
if (eAu.Test) { return; }

var CurrentTest = null;
var DS;

// Функция получает id ноды
// если была передана строка, то она и возвращается
// если был передан XML элемент, то возвращается его id
function getId(node) {
	return Object.isString(node) ? node : _Xml.id(node);
}
// Функция получает XML элемент по id
// если была передана строка, то возвращается элемент с указанным id
// если был передан XML элемент, то он и возвращается
function getNode(node) {
	return Object.isString(node) ? _Xml.$(head, node) : node;
}
function getQuestionsCache(id) {
	var ac = arguments.callee;
	ac.cache = ac.cache || {};

	id = getId(id);
	if (!ac.cache[id]) {
		ac.cache[id] = collectAllQuestions(getNode(id));
	}
	return ac.cache[id];
}
function getOptionsCache(id) {
	var ac = arguments.callee;
	ac.cache = ac.cache || {};

	id = getId(id);
	if (!ac.cache[id]) {
		ac.cache[id] = parseTestOptions(getNode(id), getQuestionsCache(id));
	}
	return ac.cache[id];
}
// Сохраняет некоторые данный по тестированиям в DS
function saveTestData() {
	var tempArray = [];
	for (var i = 0, length = loadSavedScores.indexes.length; i < length; ++i) {
		tempArray.push(
			loadSavedScores.indexes[i]
			+ '|'
			+ getOptionsCache(loadSavedScores.indexes[i])
				.get('scorePercent')
		);
	}
	DS.set('!te', tempArray.join(','));
}
// Устанавливает оценку за тест
function setScore(id, score) {
	id = getId(id);
	if (loadSavedScores.indexes.indexOf(id) == -1) {
		loadSavedScores.indexes.push(id);
	}
	getOptionsCache(id)
		.set('scorePercent', score.percent);
	getOptionsCache(id)
		.set('scoreRaw', score.raw);
	getOptionsCache(id)
		.set('scoreMax', score.max);
	getOptionsCache(id)
		.set('scoreMin', score.min);
	saveTestData();
}
function scoreTest(ct) {
	// Количество отвеченных вопросов
	var questionAnswered = 0;
	// Общее количество вопросов
	var totalQuestions = 0;
	// максимально возможный балл за тест
	var testScoreMax = 0;
	// минимально возможный балл за тест
	var testScoreMin = 0;
	// набранный балл за тест
	var testScore = 0;

	ct.q.iterate(function(i, cq) {
		var QScore = cq.get('score');
		if (!Object.isUndefined(QScore)) {
			questionAnswered++;
			testScore += QScore;
		}
		totalQuestions++;
		testScoreMax += cq.get('scoreMax');
		testScoreMin += cq.get('scoreMin');
	});

	var percent = (testScoreMax - testScoreMin == 0)
		? 0
		: Math.round((testScore - testScoreMin) * 100 / (testScoreMax - testScoreMin));

	return {
		percent: percent,
		raw: Math.floor(testScore * 100) / 100,
		max: Math.floor(testScoreMax * 100) / 100,
		min: Math.floor(testScoreMin * 100) / 100,
		q: {
			total:    totalQuestions,
			answered: questionAnswered
		}
	};
}
function loadSavedScores() {
	var ac = arguments.callee;
	ac.indexes = ac.indexes || [];

	var testDataRaw = DS.get('!te') || '';

	var tests = testDataRaw.split(',');
	if (tests.length == 1 && !tests[0]) {
		return;
	}

	for (var i = tests.length - 1; i >= 0; --i) {
		var tId = tests[i].split('|')[0];
		var node = getNode(tId);
		if (!node) { continue; }
		ac.indexes.push(tId);
		getOptionsCache(tId)
			.set('scorePercent', parseFloat(tests[i].split('|')[1]) || 0);
	}
}

function parseTestOptions(test, questions) {
	var options = $H({ });

	// Режим навигации по тесту
	// 0 - нельзя пропускать вопросы, нельзя возвращаться назад
	// 1 - с возможностью возврата к предыдущим вопросам
	// 2 - с возможностью пропускать вопросы
	options.set(
		'navigationMode',
		parseInt(_Xml.attr(test, 'navigation-mode'), 10)
				&& parseInt(_Xml.attr(test, 'navigation-mode'), 10) > 0
				&& parseInt(_Xml.attr(test, 'navigation-mode'), 10) <= 2
			? parseInt(_Xml.attr(test, 'navigation-mode'), 10)
			: 0
	);

	// Количество вопросов в тесте (0 - все вопросы)
	options.set(
		'numberOfQuestions',
		parseInt(_Xml.attr(test, 'number-of-questions'), 10) && parseInt(_Xml.attr(test, 'number-of-questions'), 10) > 0
			? parseInt(_Xml.attr(test, 'number-of-questions'), 10)
			: questions.length
	);

	// Ограничение времени на прохождение всего теста (0 - не ограничено)
	options.set(
		'timeLimit',
		parseInt(_Xml.attr(test, 'time-limit'), 10) && parseInt(_Xml.attr(test, 'time-limit'), 10) > 0
			? parseInt(_Xml.attr(test, 'time-limit'), 10)
			: 0
	);

	// Количество попыток запуска теста (0 - не ограничено)
	// TODO: NotImplemented
	// TODO: RangeCheck
	options.set(
		'numberOfTestTryes',
		parseInt(_Xml.attr(test, 'number-of-test-tryes'), 10) > 0
			? parseInt(_Xml.attr(test, 'number-of-test-tryes'), 10)
			: 0
	);

	// перемешивать вопросы
	options.set(
		'shuffleQuestions',
		_Xml.attr(test, 'shuffle-questions') == 'true'
			? true
			: false
	);

	// Позволять досрочно завершать тестирование
	options.set(
		'allowTestSkip',
		_Xml.attr(test, 'allow-test-skip') == 'true'
			? true
			: false
	);

	// Показывать общие результаты тестирования
	options.set(
		'showTestStats',
		_Xml.attr(test, 'show-test-stats') == 'true'
			? true
			: false
	);

	// Показывать общие результаты тестирования
	options.set(
		'showRightAnswers',
		_Xml.attr(test, 'show-right-answers') == 'true'
			? true
			: false
	);

	// Режим выборки вопросов для теста
	// 0 - одинаковое количество вопросов из каждой темы
	// 1 - количество вопросов задано явно
	options.set(
		'selectionMode',
		parseInt(_Xml.attr(test, "selection-mode"), 10)
				&& parseInt(_Xml.attr(test, "selection-mode"), 10) > 0
				&& parseInt(_Xml.attr(test, "selection-mode"), 10) <= 1
			? parseInt(_Xml.attr(test, "selection-mode"), 10)
			: 0
	);

	// Процент баллов, который необходимо получить что-бы пройти тест
	options.set(
		'passedPC',
		parseInt(_Xml.attr(test, "passed-pc"), 10)
				&& parseInt(_Xml.attr(test, "passed-pc"), 10) > 0
				&& parseInt(_Xml.attr(test, "passed-pc"), 10) <= 100
			? parseInt(_Xml.attr(test, "passed-pc"), 10)
			: 0
	);

	return options;
}

function generateQuestionsHash(questions) {
	var QuestionsHash = $H({ });
	var QuestionGroups = $H({ });
	var RequiredQuestionsId = [];

	for (var i = 0, length = questions.length; i < length; ++i) {
		var Question = questions[i];

		// уникальный в пределах курса Id вопроса
		var QuestionId = _Xml.id(Question);

		// Нода <answers>
		var Answers = Question.getElementsByTagName('answers')[0];

		// Тип вопроса (multiple, single, ...)
		var QuestionType = _Xml.name(Question) == 'question'
			? _Xml.attr(Question, 'type') || (!!Answers ? _Xml.attr(Answers, 'type') : null) || 'single'
			: _Xml.name(Question).replace(/question-/, '');
		if (_Xml.name(Question) == 'question' && !!Answers) {
			_Xml.attr(Answers, 'type', QuestionType);
		}
		_Xml.attr(Question, 'type', QuestionType);

		// Минимальная и максимальная оценка за вопрос
		var QuestionScoreMin = parseInt(_Xml.attr(Question, 'score-min') || '0', 10);
		var QuestionScoreMax = parseInt(_Xml.attr(Question, 'score-max') || '1', 10);

		// оценки по весам, но только для вопросов с типом "одиночный" и "множественный" выбор
		var QuestionScoreByWeights = /^(single|multiple)$/.test(QuestionType) && _Xml.attr(Question, 'score-by-weights') == 'true'
			? true
			: false;

		if (QuestionScoreByWeights) {
			QuestionScoreMin = 0;
			QuestionScoreMax = 0;
			var QuestionAnswers = !!Answers ? _Xml.collect(Answers, 'answer') : [];

			for (var l = 0, lLength = QuestionAnswers.length; l < lLength; ++l) {
				var weight = parseInt(_Xml.attr(QuestionAnswers[l], 'weight'), 10) || 0;

				if ("single" == QuestionType) {
					if (weight < QuestionScoreMin) {
						QuestionScoreMin = weight;
					} else if (weight > QuestionScoreMax) {
						QuestionScoreMax = weight;
					}
				} else {
					if (weight < 0) {
						QuestionScoreMin += weight;
					} else if (weight > 0) {
						QuestionScoreMax += weight;
					}
				}
			}
		}

		// Нормализуем значения scoreMin и scoreMax
		if (QuestionScoreMin > QuestionScoreMax) {
			QuestionScoreMin = QuestionScoreMax;
		}

		// Перемешивать ответы в вопроса (актуально не для всех типов вопросов)
		var QuestionShuffleAnswers = _Xml.attr(Question, 'shuffle-answers') == 'true' ? true : false;
		if (/sort|classify/.test(QuestionType)) {
			QuestionShuffleAnswers = true;
		}

		// Тема вопроса
		// Более сложный алгоритм для eAuthor
		// проверяем родителя: если родительская нода - question-group
		// то берём атрибут name у этой ноды (Case Sensitive)
		// и количество вопросов в выборке по этой теме
		// если существует несколько тем с одинаковым именем
		// то количество вопросов будет считано из первой встретившейся
		// Если вопрос явлеятся потомком тэга test, то QuestionGroup
		// становится '' и QuestionGroupCount устанавливается в -1
		// если по окончании цикла атрибут count всё-ещё -1,
		// то устанавливаем его значение в общее количество вопросов
		// без темы

		var QuestionGroupNode = _Xml.name(Question.parentNode) == 'question-group'
			? Question.parentNode
			: null;

		var QuestionGroup = QuestionGroupNode ? (_Xml.attr(QuestionGroupNode, 'name') || '').strip() : '';
		// список Id вопросов по каждой теме каждый элемент хэша
		// имеет также указание о количестве вопросов, которое
		// необходимо выбрать из текущей темы, если test.selectionMode == 1

		var QuestionGroupCount = QuestionGroupNode
			? parseInt((_Xml.attr(QuestionGroupNode, 'selection-limit') || '0'), 10)
			: -1;
		if (QuestionGroupNode) {
			QuestionGroupCount = QuestionGroupCount > 0 ? QuestionGroupCount : 0;
		}

		if (Object.isUndefined(QuestionGroups.get(QuestionGroup))) {
			QuestionGroups.set(QuestionGroup, $H({
				count: QuestionGroupCount,
				questions: []
			}));
		}

		if (QuestionGroupNode && QuestionGroup == '' && QuestionGroups.get('').get('count') == -1) {
			// Значит нашлась группа вопросов с пустой темой и родителем question-group
			QuestionGroups
				.get('')
				.set('count', QuestionGroupCount);
		}

		QuestionGroups
			.get(QuestionGroup)
			.get('questions')
			.push(QuestionId);

		// Если вопрос является обязательным, то заносим
		// его в список обязательных вопросов
		var QuestionIsRequired = _Xml.attr(Question, 'is-required') == 'true'
			? true
			: false;
		if (QuestionIsRequired) {
			RequiredQuestionsId.push(QuestionId);
		}

		// Ограничение времени ответа на текущий вопрос
		var QuestionTimeLimit = (parseInt(_Xml.attr(Question, 'time-limit'), 10) && parseInt(_Xml.attr(Question, 'time-limit'), 10) >= 0)
			? parseInt(_Xml.attr(Question, 'time-limit'), 10)
			: 0;

		var QuestionComments = !!Answers ? _Xml.collect(Answers, 'text') : [];
		QuestionComments = QuestionComments.concat(_Xml.collect(Question, 'comments'));
		QuestionComments = QuestionComments.select(function(comment) {
			return !/^\s*$/.test(getNodeText(comment) || '')
		});

		QuestionsHash.set(QuestionId, $H({
			tryesCount: 0,                          // количество попыток ответа на вопрос
			score: self.undefined,                  // оценка за последнюю попытку ответа на вопрос
			scoreMin: QuestionScoreMin,             // минимально возможная оценка
			scoreMax: QuestionScoreMax,             // максимально возможная оценка
			type: QuestionType,                     // тип вопроса
			htmlSerializedForm: self.undefined,     // сериализованное представление последнего ответа пользователя
			lastTry: self.undefined,                // описание последней попытки ответа на вопрос
			scoreByWeights: QuestionScoreByWeights, // режим оценки по весам или нет?
			shuffleAnswers: QuestionShuffleAnswers, // перемешивать ответы на вопрос?
			timeLimit: QuestionTimeLimit,           // ограничение времени для ответа на вопрос
			isRequired: QuestionIsRequired,         // вопрос является обязательным?
			group: QuestionGroup,                   // тема вопроса
			xmlNode: Question,                      // Xml нода вопроса
			id: QuestionId,                         // id вопроса
			comments: QuestionComments              // комментарии к ответу
		}));
	}
	
	if (QuestionGroups.get('') && QuestionGroups.get('').get('count') == -1) {
		QuestionGroups
			.get('')
			.set('count', QuestionGroups.get('').get('questions').length);
	}

	return {
		hash:     QuestionsHash,
		groups:   QuestionGroups,
		required: RequiredQuestionsId
	};
}

function generateTest(TestOptions, params) {
	var TestQuestions = [];
	var rand = TestOptions.get('shuffleQuestions');
	var HitTestHash = {};

	var QuestionGroups = params.groups.clone();
	QuestionGroups.each(function(pair) {
		QuestionGroups.set(pair.key, pair.value.clone());
	});

	// Сначала выбираем все обязательные вопросы, если необходимо перемешать,
	// то перемешаем их до начала выборки
	var RequiredQuestionIds = params.required.clone();
	if (rand) { RequiredQuestionIds.shuffle(); }

	while (RequiredQuestionIds.length) {
		// Добавляем Id вопроса в список вопросов теста
		var QId = RequiredQuestionIds.shift();
		TestQuestions.push(QId);

		// помечаем, что вопрос с данным Id уже присутствует в тесте
		// и на следующем этапе выборки не следует их брать
		HitTestHash[QId] = true;

		// FIXME: нужно ли уменьшать счётчик выборки из группы??
		var QGroup = params
			.hash
			.get(QId)
			.get('group');

		var QuestionsGroupCount = QuestionGroups
			.get(QGroup)
			.get('count');

		QuestionGroups
			.get(QGroup)
			.set('count', QuestionsGroupCount - 1);
	}

	switch(TestOptions.get('selectionMode')) {
		case 0:
			// Отнимаем то количество вопросов, которое уже добавлено в тест
			var nOfQuestions = TestOptions.get('numberOfQuestions') - TestQuestions.length;

			// Теперь берём из каждой группы по вопросу пока не исчерпаем лимит
			// если необходимо перемешивание, то перемешаем группы
			var Groups = QuestionGroups.keys();
			if (rand) { Groups.shuffle(); }

			while (nOfQuestions > 0) {
				var LeftQuestions = 0;
				for (var j = 0; j < Groups.length; ++j) {
					if (nOfQuestions <= 0) { break; }

					// Получаем список вопросов в текщей теме
					var questions = QuestionGroups
						.get(Groups[j])
						.get('questions')
						.clone();

					// Перемешиваем их, если потребуется
					if (rand) { questions.shuffle() }

					// до тех пор пока не найдём "свежего" вопроса или
					// пока вопросы не кончатся, ищем вопрос
					while (questions.length) {
						var QId = questions.shift();
						if (HitTestHash[QId]) { continue; }

						// если нашли подходящий вопрос, то добавляем его в список
						TestQuestions.push(QId);
						HitTestHash[QId] = true;
						--nOfQuestions;
						break;
					}
					LeftQuestions += questions.length;
				}

				if (LeftQuestions == 0) { break; }
			}
			break;
		case 1:
			// Теперь берём из каждой группы по необходимому количеству вопросов
			// здесь можно обойтись и без перемешивания
			var Groups = QuestionGroups.keys();
			QuestionGroups.each(function(pair) {
				// Получаем список вопросов в текщей теме
				var questions = pair.value.get('questions').clone();
				// Перемешиваем их, если потребуется
				if (rand) { questions.shuffle() }

				// узнаём количество вопросов, которое необходимо выбрать из темы
				var questionsN = pair.value.get('count');

				// пока есть вопросы в теме добавляем их в тест
				for (var i = 0, length = questions.length; i < length; ++i) {
					// если достигли ограничения - прерываемся
					if (questionsN <= 0) { break; }

					var QId = questions[i];
					if (HitTestHash[QId]) { continue; }
					// нашли подходящий вопрос, добавляем
					TestQuestions.push(QId);
					HitTestHash[QId] = true;
					--questionsN;
				}
			});
			break;
	}

	if (rand) { TestQuestions.shuffle(); }

	return TestQuestions;
}

function collectAllQuestions(test) {
	var tempQuestions = _Xml.collect(test, 'question question-exercise question-group');
	var __questions = [];
	for (var i = 0, length = tempQuestions.length; i < length; ++i) {
		if (_Xml.name(tempQuestions[i]) == 'question-group') {
			__questions = __questions.concat(
				_Xml.collect(tempQuestions[i], 'question question-exercise')
			);
		} else {
			__questions.push(tempQuestions[i]);
		}
	}
	return __questions;
}

var QuestionClass = Class.create({
	initialize: function(testObject, questions) {
		this._test = testObject;
		var params = generateQuestionsHash(questions);

		this._questionsHash = params.hash;
		this._testQuestionIds = generateTest(this._test._options, params);
		this._testQuestionQueue = this._testQuestionIds.clone();
		this._currentPosition = 0;
	},
	iterate: function(iterator) {
		for (var i = 0, length = this._testQuestionIds.length; i < length; ++i) {
			var val = null;
			try {
				iterator(i, this._questionsHash.get(this._testQuestionIds[i]));
			} catch (e) {
				if (e != eAu.$break) {
					throw e;
				} else {
					break;
				}
			}
		}
	},
	get: function(what) {
		what = (what || 'current').toLowerCase();

		var getters = {
			next: function($super) {
				if (this._test.getOption('navigationMode') == 2 && this._testQuestionQueue.length == 1) {
					return $super.current();
				}

				var QId = this._testQuestionQueue[this._currentPosition + 1];
				if (Object.isUndefined(QId)) { return QId; }
				return this._questionsHash.get(QId);
			},
			previous: function() {
				var QId = this._testQuestionQueue[this._currentPosition - 1];
				if (Object.isUndefined(QId)) { return QId; }
				return this._questionsHash.get(QId);
			},
			current: function() {
				var QId = this._testQuestionQueue[this._currentPosition];
				if (Object.isUndefined(QId)) { return QId; }
				return this._questionsHash.get(QId);
			}
		};

		// Для удобства
		getters.c = getters.cur = getters.current;
		getters.n = getters.next;
		getters.p = getters.prev = getters.previous;

		if (getters[what]) {
			return getters[what].call(this, getters);
		}
	},
	// Если вопрос последний, это не значит что getNextQuestion вернёт null
	isLast: function() {
		return this._currentPosition == this._testQuestionQueue.length - 1;
	},
	isFirst: function() {
		return false;
	},
	getPosition: function() {
		var QId = this._testQuestionQueue[this._currentPosition];
		if (Object.isUndefined(QId)) {
			return -1;
		}
		return this._testQuestionIds.indexOf(QId) + 1
	},
	getLength: function() {
		return this._testQuestionIds.length;
	},
	getLeft: function() {
		return this._testQuestionQueue.length - this._currentPosition;
	},
	// Просто модифицирует очередь
	next: function() {
		// Если запрещён возврат к предыдущему вопросу, то не имеет смысла
		// хранить его Id в очереди, просто удаляем его
		if (this._test.getOption('navigationMode') != 1) {
			this._testQuestionQueue.shift();
			return;
		}
		// Иначе, перемещаем указатель текущей позиции вперёд
		// Никаких проверок, пусть ui.js этим занимается
		this._currentPosition++;
	},
	skip: function() {
		// Если нам запрещено пропускать вопросы, то прерываем функцию
		if (this._test.getOption('navigationMode') != 2) {
			return;
		}
		// Иначе, извлекаем вопрос с начала очереди и добавляем его в самы конец
		var QId = this._testQuestionQueue.shift();
		this._testQuestionQueue.push(QId);
	},
	previous: function() {
		// Если нам запрещено возвращаться назад, то прерываем функцию
		if (this._test.getOption('navigationMode') != 1) {
			return;
		}

		// Иначе, перемещаем указатель текущей позиции назад
		// Никаких проверок, пусть ui.js этим занимается
		this._currentPosition--;
	}
});

eAu.Test = Class.create({
	initialize: function(test) {
		this.__testNode = test;
		this.__testId = _Xml.id(this.__testNode);
		this.__questions = getQuestionsCache(this.__testId);
		// Получаем настройки тестирования
		this._options = getOptionsCache(this.__testId);
	},
	start: function() {
		if (this.__started) {
			return;
		}

		this.q = this.questions = new QuestionClass(this, this.__questions);

		this.__result = $H({
			startTime: (new Date()).getTime()
		});

		this.__started = true;
	},
	finish: function(finishMode) {
		if (!this.__started || this.__finished) {
			return;
		}

		this
			.__result
			.set('endTime', (new Date()).getTime());

		this.__finished = true;
	},
	score: function(saveScore) {
		var score = scoreTest(this);
		if (saveScore) {
			setScore(this.__testId, score);
		}
		return score;
	},
	getTestNode: function() {
		return this.__testNode;
	},
	getOption: function(name) {
		return eAu.Test.getOption(this.__testId, name);
	},
	passed: function() {
		return eAu.Test.passed(this.__testId);
	},
	attempted: function() {
		return eAu.Test.attempted(this.__testId);
	}
});

eAu.Test.init = function(DataStorageEngine) {
	DS = DataStorageEngine;
	loadSavedScores();
	saveTestData();
}
eAu.Test.newTest = function(testNode) {
	CurrentTest = new eAu.Test(testNode);
	return CurrentTest;
}
eAu.Test.getCurrent = function() {
	return CurrentTest;
}
eAu.Test.getOption = function(id, name) {
	id = getId(id);
	return getOptionsCache(id)
		.get(name);
}
eAu.Test.passed = function(id) {
	var options = getOptionsCache(getId(id));
	var scorePercent = options.get('scorePercent');
	var passedPercent = options.get('passedPC');

	return eAu.Test.attempted(id) && (scorePercent >= passedPercent);
}
eAu.Test.attempted = function(id) {
	return !Object.isUndefined(getOptionsCache(getId(id)).get('scorePercent'));
}

})();

