/* BEGIN: Search */
function executeSearchQuery() {
	var form = document.forms['search-form'];
	if (!form) { return; }
	var inputField = form['search-input'];
	if (inputField.value.length <= 0) {
		$(inputField).addClass('eAu-error-input');
		return;
	}

	var options = {
		mode: 'all',
		type: 'any',
		str:  ''
	};
	var searchType = 'all';
	for (var i = 0; i < form['search-type'].length; ++i) {
		if (form['search-type'][i].checked) {
			searchType = form['search-type'][i].value;
			break;
		}
	}
	DS.set('search-type', searchType);
	DS.set('search-string', inputField.value);
	DS.set('search-mode', form['search-mode'].value);
	options.mode = DS.get('search-mode');
	options.type = DS.get('search-type');
	options.str = DS.get('search-string');

	loadingProxy();
}

function fillSearchInputs(optionIndex) {
	var options = self.searches[optionIndex];
	var smode = document.getElementById('search-mode');
	var stype = document.getElementById('search-type');
	var sstr = document.getElementById('search-input');

	if (options.type == 'all') {
		stype.checked = true;
	} else {
		stype.checked = false;
	}
	for (var i = 0; i < smode.length; ++i) {
		if (smode[i].value == options.mode) {
			smode.selectedIndex = i;
			break;
		}
	}
	for (var i = 0; i < stitle.length; ++i) {
		if (stitle[i].value == options.title) {
			stitle.selectedIndex = i;
			break;
		}
	}
	sstr.value = options.str;
}

function getSearchSelect() {
	var mode = DS.get('search-mode');
	var appendixes = head.selectNodes("//appendix-item");
	var ret = {
		first: [
			'<select class="search-mode eAu-input-text" id="search-mode" name="search-mode">',
			'	<option value="current" '+ (mode == 'current' ? 'selected' : '') +'>В текущем модуле</option>',
			use_internal_navigation ? '	<option value="all" '+ (mode == 'all' ? 'selected' : '') +'>Везде</option>' : '',
			(appendixes.length > 0 && use_internal_navigation) ? '	<option value="all-course" '+ (mode == 'all-course' ? 'selected' : '') +'>В основных материалах курса</option>' : '',
			(appendixes.length > 0) ? '	<option value="all-appendixes" '+ (mode == 'all-appendixes' ? 'selected' : '') +'>В дополнительных материалах курса</option>' : '',
			use_internal_navigation ? '	<option value="headers" '+ (mode == 'headers' ? 'selected' : '') +'>В заголовках</option>' : '',
			'</select>'
		]
	};
	ret.first = ret.first.join('');
	ret.third = mode;
	return ret;
}

function loadSearchPage() {
	var value = '';
	var checked = '';
	if (DS.has('search-string')) {
		value = DS.get('search-string');
	} else if (DS.has('|lastSearch_searchString')) {
		value = DS.get('|lastSearch_searchString');
	}
	if (DS.get('search-type') != 'any') {
		checked = 'all';
	}
	var searchOptions = getSearchSelect();
	var searchForm = [
		'<h1 class="eAu">Расширенный поиск</h1>',
		'<form onsubmit="executeSearchQuery(); return false;" name="search-form" class="eAu-search-form">',
		'	<table border="0" cellspacing="0" cellpadding="0" width="100%">',
		'		<tr>',
		'			<td valign="middle" width="40%">',
		'				<input value="'+value+'" type="text" id="search-input" class="eAu-input-text eAu-search-input" name="search-input"',
		'					onkeypress="$(this).removeClass(\'eAu-error-input\');"/>',
		'			</td>',
		'			<td width="1">',
		'				<input type="image" src="images/buttons/search.gif" onclick="executeSearchQuery(); return false;" title="Найти" class="eAu-search-form-submit" />',
		'			</td>',
		//'			<td width="1"><a href="index.htm" target="_top" onclick="executeSearchQuery(); return false;" title="Найти" class="eAu-search-form-submit">Найти</a></td>',
		'			<td></td>',
		'		</tr>',
		'	</table>',
		'	<h2 class="eAu">Параметры поиска</h2>',
		'	<div><input type="radio" name="search-type" value="any" id="search-type-0" ' + (checked == 'all' ? '' : ' checked="checked" ') +' /> <label for="search-type-0">Найти отдельные слова</label></div>',
		'	<div><input type="radio" name="search-type" value="all" id="search-type-1" ' + (checked == 'all' ? ' checked="checked" ' : '') +' /> <label for="search-type-1">Найти фразу целиком</label></div>',
		'	<table border="0" cellpadding="0" cellspacing="0" style="margin-top: 6px;"><tr>',
		'		<td><div>Где искать:&nbsp;</div></td>',
		'		<td>'+ searchOptions.first+'</td>',
		'	</tr></table>',
		'</form>'
	].join('');

	$('#cont').html('<div class="eAu-search">' + searchForm + '<div class="eAu-search-results" id="eAu-search-results"></div></div>');
}
function getMatchesFromPackedString(str) {
	var matchIds = str.split(/\s+/);
	var matches = [];
	for (var i = 0; i < matchIds.length; ++i) {
		var match = _Xml.$(head, matchIds[i]);
		if (match) {
			matches.push(match);
		}
	}
	return matches;
}
function packMatchesIntoString(matches) {
	var str = [];
	for (var i = 0; i < matches.length; ++i) {
		str.push(_Xml.id(matches[i]));
	}
	return str.join(' ');
}
function getSearchResults() {
	$('#cont').html('');
	loadSearchPage();
	if (DS.get('search-string')) {
		$('#eAu-search-results').html('<div class="eAu-content-dotted-line"></div><h1 class="eAu">Результаты поиска</h1><div id="eAu-search-results-list"></div>');
		var searchOptions = {
			mode: 'all',
			type: 'any'
		};
		if (DS.has('search-mode')) {
			searchOptions.mode = DS.get('search-mode');
		}
		if (DS.has('search-type')) {
			searchOptions.type = DS.get('search-type');
		}
		showContentLoader($('#eAu-search-results-list'));
		setTimeout(function() {
			var matches = contextSearch(DS.get('search-string'), searchOptions);
			printSearchResults(matches, 'eAu-search-results-list');
		}, 10);
	} else if (DS.has('|lastSearch_searchString') && DS.has('|lastSearch_searchResults')) {
		$('#eAu-search-results')
			.html('<div class="eAu-content-dotted-line"></div><h1 class="eAu">Результаты поиска</h1><div id="eAu-search-results-list"></div>');
		DS.set('search-string', DS.get('|lastSearch_searchString'));
		printSearchResults(getMatchesFromPackedString(DS.get('|lastSearch_searchResults')), 'eAu-search-results-list');
	}
}
function printSearchResults(matches,outputHtmlId) {
	var node = document.getElementById(outputHtmlId);
	var output = [];
	output.push('<ul class="eAu-search-result-items">');
	for (var i = 0, length = matches.length; i < length; ++i) {
		_Xml.fetch(matches[i], true);
		output.push('<li class="eAu-search-result-item">');
		output.push('	<h2 class="eAu">');
		output.push('		<a href="index.htm" onclick="link_info(\''+_Xml.id(matches[i])+'\'); return false;" target="_top">');
		output.push(			_Xml.title(matches[i]));
		output.push(		'</a>');
		output.push('	</h2>');
		output.push('	<div>');
		var text = getNodeText(matches[i]).stripTags().unescape().norm();
		output.push(			text.length > 300 ? text.substr(0, 300) + '…' : text);
		output.push('	</div>');
		output.push('</li>');
	}
	output.push('</ul>');
	if (matches.length == 0) {
		output = ['<div class="eAu-search-results"><div class="eAu-nothing-found">По вашему запросу ничего не найдено.</div></div>'];
	}
	DS.set('|lastSearch_searchString', DS.get('search-string'));
	DS.set('|lastSearch_searchResults', packMatchesIntoString(matches));
	node.innerHTML = text_transform(output.join(''));
	if (DS.get('|lastSearch_searchString')) {
		DS.set('search-string', DS.get('|lastSearch_searchString'));
	}
}
function contextSearch(searchString, searchOptions) {
	if (!searchString) { return; }
	var context = head;
	switch (searchOptions.mode) {
		case 'headers':
			context = null;
			break;
		case 'all-appendixes':
			var tmpContext = head.selectNodes("//appendix-item");
			context = [];
			for (var i = 0; i < tmpContext.length; ++i) {
				context.push(tmpContext.item(i));
			}
			break;
		case 'current':
			if (DS.has('id')) {
				context = _Xml.$(head, DS.get('id')) || head;
				context = _Xml.parentOrSelf(context, 'subject test studiedproblem') || context;
			}
			break;
	}
	if (context) {
		if (Object.isArray(context)) {
			for (var i = 0; i < context.length; ++i) {
				_Xml.fetch(context[i], true);
			}
		} else {
			_Xml.fetch(context, true);
		}
	}
	var nodesList = [];
	switch (searchOptions.mode) {
		case 'headers':
			nodesList = head.selectNodes(["//lesson",
				"//unit",
				"//studiedproblem",
				"//test"].join('|'));
			break;
		case 'current':
			nodesList = context.selectNodes(["descendant-or-self::studiedproblem[not(@group-text-nodes = 'false')]",
				"descendant-or-self::text[../@group-text-nodes = 'false']"
			].join('|'));
			break;
		case 'all-appendixes':
			nodesList = head.selectNodes("descendant::appendix-item/descendant::studiedproblem");
			break;
		case 'all-course':
			nodesList = head.selectNodes(["//studiedproblem[not(@group-text-nodes = 'false')]",
				"//text[../@group-text-nodes = 'false']"
			].join('|'));
			var NodesList = [];
			for (var i = 0, length = nodesList.length; i < length; ++i) {
				if (_Xml.parent(nodesList[i], 'appendix-item glossary') == null) {
					NodesList.push(nodesList[i]);
				}
			}
			nodesList = NodesList;
			break;
		default:
		case 'all':
			nodesList = head.selectNodes(["//studiedproblem[not(@group-text-nodes = 'false')]",
				"//text[../@group-text-nodes = 'false']"
			].join('|'));
			break;
	}
	var searchNodes = [];
	var str = [];
	for (var i = 0, length = nodesList.length; i < length; ++i) {
		if (_Xml.isVisible(nodesList[i], true) || _Xml.parentOrSelf(nodesList[i], 'appendix-item')) {
			searchNodes.push(nodesList[i]);
		}
	}
	delete nodesList;
	var searchTerms = searchString.trim().toLowerCase().norm().split(' ');
	var matches = [], text, matched, pos, character;
	switch (searchOptions.mode) {
	case 'headers':
		for (var i = 0, length = searchNodes.length; i < length; ++i) {
			matched = 0;
			text = _Xml.title(searchNodes[i]).stripTags().unescape().norm().toLowerCase();
			if (searchOptions.type == 'all') {
				pos = text.match(new RegExp("(^|\\s)"+searchTerms.join(' ')+"(\\s|,\\.:\\?!;\"'\\)%|$)"));
				if (pos && pos.length > 0) {
					matched = 1;
				}
			} else {
				for (var j = 0; j < searchTerms.length; ++j) {
					pos = text.match(new RegExp("(^|\\s)"+searchTerms[j]+"(\\s|,\\.:\\?!;\"'\\)%|$)"));
					if (pos && pos.length > 0) {
						matched = 1;
						break;
					}
				}
			}
			if (matched > 0) {
				matches.push(searchNodes[i]);
			}
		}
		break;
	default:
		for (var i = 0, length = searchNodes.length; i < length; ++i) {
			matched = 0;
			text = getNodeText(searchNodes[i]).stripTags().unescape().norm().toLowerCase().strip();
			if (searchOptions.type == 'all') {
				pos = text.match(new RegExp("(^|\\s|[:\\[\\(\\)\\\\/\\\"'*#$\\-=+~`«‘’‚‛“”„])"+searchTerms.join(' ')+"(\\s|[;%\\]\\(\\)\\\\/\\.:?!\"'*#$\\-=+~`,»‘’‚‛“”„…]|$)"));
				if (pos && pos.length > 0) {
					matched = 1;
				}
			} else {
				for (var j = 0; j < searchTerms.length; ++j) {
					pos = text.match(new RegExp("(^|\\s|[:\\[\\(\\)\\\\/\\\"'*#$\\-=+~`«‘’‚‛“”„])"+searchTerms[j]+"(\\s|[;%\\]\\(\\)\\\\/\\.:?!\"'*#$\\-=+~`,»‘’‚‛“”„…]|$)"));
					if (pos && pos.length > 0) {
						matched = 1;
						break;
					}
				}
			}
			if (matched > 0) {
				matches.push(searchNodes[i]);
			}
		}
		break;
	}
	return matches;
}
function loadSearchPageEx() {
	DS.unset('glossary');
	DS.unset('appendix-id');
	DS.set('search', '');
	loadingProxy();
}
/* END: Search */
